"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importDefault(require("react"));
const utils_1 = require("@onesy/utils");
const style_react_1 = require("@onesy/style-react");
const AutoComplete_1 = __importDefault(require("../AutoComplete"));
const ListItem_1 = __importDefault(require("../ListItem"));
const Type_1 = __importDefault(require("../Type"));
const utils_2 = require("../utils");
const useStyle = (0, style_react_1.style)(theme => ({
    root: {}
}), { name: 'onesy-AutoCompleteGooglePlaces' });
const AutoCompleteGooglePlaces = react_1.default.forwardRef((props_, ref) => {
    const theme = (0, style_react_1.useOnesyTheme)();
    const props = react_1.default.useMemo(() => { var _a, _b, _c, _d, _e, _f, _g, _h; return (Object.assign(Object.assign(Object.assign({}, (_d = (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _a === void 0 ? void 0 : _a.elements) === null || _b === void 0 ? void 0 : _b.all) === null || _c === void 0 ? void 0 : _c.props) === null || _d === void 0 ? void 0 : _d.default), (_h = (_g = (_f = (_e = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _e === void 0 ? void 0 : _e.elements) === null || _f === void 0 ? void 0 : _f.onesyAutoCompleteGooglePlaces) === null || _g === void 0 ? void 0 : _g.props) === null || _h === void 0 ? void 0 : _h.default), props_)); }, [props_]);
    const AutoComplete = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.AutoComplete) || AutoComplete_1.default; }, [theme]);
    const ListItem = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.ListItem) || ListItem_1.default; }, [theme]);
    const Type = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Type) || Type_1.default; }, [theme]);
    const { value, valueDefault, valueInputDefault: valueInputDefault_, onChangeInput: onChangeInputProps, size = 'regular', optionsGoogle: optionsGoogle_, className, children } = props, other = __rest(props, ["value", "valueDefault", "valueInputDefault", "onChangeInput", "size", "optionsGoogle", "className", "children"]);
    const { classes } = useStyle();
    const [places, setPlaces] = react_1.default.useState([]);
    const refs = {
        google: react_1.default.useRef(undefined)
    };
    const optionsGoogle = react_1.default.useMemo(() => {
        return optionsGoogle_ || {
            fields: ['name', 'address_component', 'location', 'geometry']
        };
    }, [optionsGoogle_]);
    const onGoogleResults = react_1.default.useCallback((results) => {
        // update places
        setPlaces((results === null || results === void 0 ? void 0 : results.map((item) => (Object.assign(Object.assign({}, item), { name: item.description })))) || []);
    }, []);
    const init = react_1.default.useCallback(async () => {
        if (!window.google)
            return;
        const google = window.google;
        const { AutocompleteService } = await google.maps.importLibrary('places');
        refs.google.current = new AutocompleteService(undefined, options);
    }, []);
    react_1.default.useEffect(() => {
        // init
        init();
    }, []);
    const onChangeInput = react_1.default.useCallback((0, utils_1.debounce)((valueNew) => {
        if ((0, utils_1.is)('function', onChangeInputProps))
            onChangeInputProps(valueNew);
        if (!refs.google.current)
            return;
        // Make a Google request
        refs.google.current.getQueryPredictions({ input: valueNew }, onGoogleResults);
    }, 440), [optionsGoogle, onChangeInputProps]);
    const options = react_1.default.useMemo(() => {
        return places.map((item) => (Object.assign(Object.assign({}, item), { value: item.name })));
    }, [places]);
    const valueInputDefault = react_1.default.useMemo(() => {
        var _a;
        return valueInputDefault_ !== undefined ? valueInputDefault_ : (_a = options.find((item) => item.value === (value !== undefined ? value : valueDefault))) === null || _a === void 0 ? void 0 : _a.name;
    }, []);
    return ((0, jsx_runtime_1.jsx)(AutoComplete, Object.assign({ ref: ref, valueInputDefault: valueInputDefault, valueDefault: valueDefault, value: value, options: options, onChangeInput: onChangeInput, size: size, renderOption: (item, index_, propsItem) => ((0, jsx_runtime_1.jsx)(ListItem, Object.assign({ start: item.flag, startAlign: 'center', primary: ((0, jsx_runtime_1.jsx)(Type, Object.assign({ version: 'b3' }, { children: item.name }))), value: item.value, selected: item.value === ((value === null || value === void 0 ? void 0 : value.value) !== undefined ? value === null || value === void 0 ? void 0 : value.value : value), size: 'small', button: true }, propsItem), index_)), className: (0, style_react_1.classNames)([
            (0, utils_2.staticClassName)('AutoCompleteGooglePlaces', theme) && [
                'onesy-AutoCompleteGooglePlaces-root',
                `onesy-AutoCompleteGooglePlaces-size-${size}`
            ],
            className,
            classes.root
        ]) }, other)));
});
AutoCompleteGooglePlaces.displayName = 'onesy-AutoCompleteGooglePlaces';
exports.default = AutoCompleteGooglePlaces;
