import React from 'react';
import { OnesyDate } from '@onesy/date';
import { ILine } from '../Line/Line';
import { IElement } from '../types';
import { ICalendarViewsView } from '../CalendarViews/CalendarViews';
export declare type ICalendarEvent = {
    id?: string;
    description?: string;
    from?: number;
    to?: number;
    status?: string;
    color?: string;
};
export declare type ICalendarAvailability = ILine & {
    name?: string | IElement;
    date?: OnesyDate;
    dateDefault?: OnesyDate;
    times?: any;
    events?: ICalendarEvent[];
    meta?: boolean;
    views?: {
        name: string;
        value: ICalendarViewsView;
    }[];
    onUpdate?: (object?: any) => any;
    onRemove?: (object?: any) => any;
    onChangeDate?: (value: OnesyDate) => any;
    startHeader?: any;
    endHeader?: any;
    startLeft?: any;
    endLeft?: any;
    startRight?: any;
    endRight?: any;
    startLeftModal?: any;
    endLeftModal?: any;
    startRightModal?: any;
    endRightModal?: any;
    IconPrevious?: any;
    IconNext?: any;
    IconDescription?: any;
    IconEdit?: any;
    IconRemove?: any;
    IconClose?: any;
    WeekProps?: any;
    DayProps?: any;
    IconProps?: any;
    IconButtonProps?: any;
};
declare const CalendarAvailability: React.FC<ICalendarAvailability>;
export default CalendarAvailability;
