import React from 'react';
import { OnesyDate } from '@onesy/date';
import { ICalendar } from '../Calendar/Calendar';
import { ICalendarEvent } from '../CalendarAvailability/CalendarAvailability';
export declare type ICalendarViewsView = 'day' | 'week' | 'month';
export declare type ICalendarViews = ICalendar & {
    viewDefault?: ICalendarViewsView;
    dateDefault?: OnesyDate;
    times?: any;
    events?: ICalendarEvent[];
    views?: {
        name: string;
        value: ICalendarViewsView;
    }[];
    render?: (date: OnesyDate, view: ICalendarViewsView) => any;
    onTimeClick?: (date: OnesyDate, view: ICalendarViewsView, event: MouseEvent) => any;
    onChangeView?: (view: ICalendarViewsView) => any;
    onChangeDate?: (value: OnesyDate) => any;
    startHeader?: any;
    endHeader?: any;
    startLeft?: any;
    endLeft?: any;
    startRight?: any;
    endRight?: any;
    noViews?: boolean;
    IconPrevious?: any;
    IconNext?: any;
    WeekProps?: any;
    DayProps?: any;
    CalendarMonthProps?: any;
    TypeDateFormattedProps?: any;
};
declare const CalendarViews: React.FC<ICalendarViews>;
export default CalendarViews;
