import React from 'react';
import { OnesyDate } from '@onesy/date';
import { IRoundMeter } from '../RoundMeter/RoundMeter';
export declare type TClockValue = OnesyDate;
export declare type TClockFormat = '12' | '24';
export declare type TClockUnit = 'hour' | 'minute' | 'second';
export declare type TClockDayTime = 'am' | 'pm';
export declare type IClock = Omit<IRoundMeter, 'onChange'> & {
    value?: TClockValue;
    valueDefault?: TClockValue;
    onChange?: (value: TClockValue) => any;
    selecting?: TClockUnit;
    selectingDefault?: TClockUnit;
    onChangeSelecting?: (value: TClockUnit) => any;
    format?: TClockFormat;
    dayTime?: TClockDayTime;
    hour?: boolean;
    minute?: boolean;
    second?: boolean;
    autoNext?: boolean;
    min?: OnesyDate;
    max?: OnesyDate;
    validate?: (value: OnesyDate) => boolean;
    valid?: (value: OnesyDate, selecting: TClockUnit) => any;
    renderValue?: (value: TClockValue, version: TClockUnit, x: number, y: number, valueNumber: number, otherProps: any) => React.ReactNode;
    onDoneSelecting?: (value: TClockValue, selecting: TClockUnit) => any;
};
declare const Clock: React.FC<IClock>;
export default Clock;
