"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SEPARATOR = exports.SEPARATOR_SYMBOL = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importDefault(require("react"));
const utils_1 = require("@onesy/utils");
const date_1 = require("@onesy/date");
const style_react_1 = require("@onesy/style-react");
const IconMaterialCalendarTodayW100Filled_1 = __importDefault(require("@onesy/icons-material-rounded-react/IconMaterialCalendarTodayW100Filled"));
const IconMaterialEditW100_1 = __importDefault(require("@onesy/icons-material-rounded-react/IconMaterialEditW100"));
const IconMaterialCloseW100_1 = __importDefault(require("@onesy/icons-material-rounded-react/IconMaterialCloseW100"));
const IconButton_1 = __importDefault(require("../IconButton"));
const Button_1 = __importDefault(require("../Button"));
const AdvancedTextField_1 = __importDefault(require("../AdvancedTextField"));
const Modal_1 = __importDefault(require("../Modal"));
const Tooltip_1 = __importDefault(require("../Tooltip"));
const Surface_1 = __importDefault(require("../Surface"));
const Line_1 = __importDefault(require("../Line"));
const Type_1 = __importDefault(require("../Type"));
const Calendar_1 = __importDefault(require("../Calendar"));
const Divider_1 = __importDefault(require("../Divider"));
const Slide_1 = __importDefault(require("../Slide"));
const ClickListener_1 = __importDefault(require("../ClickListener"));
const useMediaQuery_1 = __importDefault(require("../useMediaQuery"));
const utils_2 = require("../utils");
const useStyle = (0, style_react_1.style)(theme => ({
    root: {},
    header: {
        width: '100%',
        padding: `${theme.methods.space.value(2, 'px')} ${theme.methods.space.value(3, 'px')} 0px`,
        flex: '0 0 auto'
    },
    header_fullScreen: {
        padding: `${theme.methods.space.value(2, 'px')} 0px 0px`
    },
    actions: {
        width: '100%',
        padding: `0px ${theme.methods.space.value(1, 'px')} ${theme.methods.space.value(1.5, 'px')} ${theme.methods.space.value(1.5, 'px')}`,
        flex: '0 0 auto',
        overflowX: 'auto'
    },
    mode: {
        overflow: 'hidden'
    },
    calendar_mobile: {
        '&.onesy-Calendar-root': {
            width: '100%'
        },
        '& .onesy-Calendar-header + .onesy-Divider-root': {
            display: 'none'
        }
    },
    input_mobile: {
        '&.onesy-TextField-root': {
            width: '100%'
        }
    },
    mobile: {
        width: 'calc(100vw - 48px)',
        maxWidth: '330px',
        margin: '0 auto',
        borderRadius: theme.methods.shape.radius.value(3.5, 'px'),
        overflow: 'hidden',
        '& .onesy-Calendar-root': {
            borderRadius: '0'
        }
    },
    mobile_fullScreen: {
        height: '100vh',
        width: '100vw',
        margin: '0',
        maxWidth: 'unset',
        borderRadius: '0'
    },
    modal_input: {
        width: '100%',
        padding: `${theme.methods.space.value(2, 'px')} ${theme.methods.space.value(3, 'px')} ${theme.methods.space.value(2, 'px')}`,
        marginBottom: '12px',
        flex: '1 1 auto'
    },
    dayNames: {
        width: '100%',
        padding: `0 ${theme.methods.space.value(1, 'px')}`
    },
    dayName: {
        width: '40px',
        height: '40px',
        flex: '1 1 auto',
        userSelect: 'none'
    },
    heading: {
        width: '100%',
        marginBottom: '12px'
    },
    heading_fullScreen: {
        paddingInline: `${theme.methods.space.value(7.5, 'px')} ${theme.methods.space.value(1.5, 'px')}`
    },
    subheading: {
        width: '100%',
        marginBottom: '36px'
    },
    subheading_fullScreen: {
        margin: '8px 0',
        marginInlineStart: '60px'
    },
    divider: {
        '&.onesy-Divider-root': {
            margin: '0'
        }
    }
}), { name: 'onesy-DatePicker' });
exports.SEPARATOR_SYMBOL = `–`;
exports.SEPARATOR = ` ${exports.SEPARATOR_SYMBOL} `;
const DatePicker = react_1.default.forwardRef((props__, ref) => {
    const theme = (0, style_react_1.useOnesyTheme)();
    const l = theme.l;
    const props = react_1.default.useMemo(() => { var _a, _b, _c, _d, _e, _f, _g, _h; return (Object.assign(Object.assign(Object.assign({}, (_d = (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _a === void 0 ? void 0 : _a.elements) === null || _b === void 0 ? void 0 : _b.all) === null || _c === void 0 ? void 0 : _c.props) === null || _d === void 0 ? void 0 : _d.default), (_h = (_g = (_f = (_e = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _e === void 0 ? void 0 : _e.elements) === null || _f === void 0 ? void 0 : _f.onesyDatePicker) === null || _g === void 0 ? void 0 : _g.props) === null || _h === void 0 ? void 0 : _h.default), props__)); }, [props__]);
    const Line = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Line) || Line_1.default; }, [theme]);
    const IconButton = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.IconButton) || IconButton_1.default; }, [theme]);
    const Button = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Button) || Button_1.default; }, [theme]);
    const AdvancedTextField = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.AdvancedTextField) || AdvancedTextField_1.default; }, [theme]);
    const Modal = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Modal) || Modal_1.default; }, [theme]);
    const Tooltip = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Tooltip) || Tooltip_1.default; }, [theme]);
    const Surface = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Surface) || Surface_1.default; }, [theme]);
    const Type = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Type) || Type_1.default; }, [theme]);
    const Calendar = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Calendar) || Calendar_1.default; }, [theme]);
    const Divider = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Divider) || Divider_1.default; }, [theme]);
    const Slide = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Slide) || Slide_1.default; }, [theme]);
    const ClickListener = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.ClickListener) || ClickListener_1.default; }, [theme]);
    const { tonal = true, color = 'primary', version: version_ = 'auto', size = 'regular', value: value_, valueDefault, onChange, calendar: calendar_, calendarDefault, onChangeCalendar, range, now, static: static_, openMobile = 'select', placeholder: placeholder_, calendars = props.range ? 2 : 1, min, max, validate, name, nameFrom, nameTo, label: label_, labelFrom: labelFrom_ = l('Date from'), labelTo: labelTo_ = l('Date to'), modeModalSubHeadingText = l('Select date'), modeModalSubHeadingTextRange = `${l('Date from')}${exports.SEPARATOR}${l('Date to')}`, selectModeHeadingText = l('Select date'), inputModeHeadingText = l('Enter date'), useHelperText: useHelperText_, weekStartDay = 'Monday', switch: switch__, fullScreen, today, clear = true, heading: heading_ = true, actions: actions_ = true, fullWidth, readOnly, disabled, valid: valid_, onClick: onClick_, onClose: onClose_, onToday: onToday_, onClear: onClear_, onCancel: onCancel_, onOk: onOk_, Icon: Icon_ = IconMaterialCalendarTodayW100Filled_1.default, IconEnter = IconMaterialEditW100_1.default, IconClose = IconMaterialCloseW100_1.default, WrapperProps, CalendarProps, CalendarPropsDesktop, CalendarPropsMobile, IconButtonProps, AdvancedTextFieldProps, TooltipProps, ButtonProps, ModalProps, IconProps, MobileSurfaceProps, className } = props, other = __rest(props, ["tonal", "color", "version", "size", "value", "valueDefault", "onChange", "calendar", "calendarDefault", "onChangeCalendar", "range", "now", "static", "openMobile", "placeholder", "calendars", "min", "max", "validate", "name", "nameFrom", "nameTo", "label", "labelFrom", "labelTo", "modeModalSubHeadingText", "modeModalSubHeadingTextRange", "selectModeHeadingText", "inputModeHeadingText", "useHelperText", "weekStartDay", "switch", "fullScreen", "today", "clear", "heading", "actions", "fullWidth", "readOnly", "disabled", "valid", "onClick", "onClose", "onToday", "onClear", "onCancel", "onOk", "Icon", "IconEnter", "IconClose", "WrapperProps", "CalendarProps", "CalendarPropsDesktop", "CalendarPropsMobile", "IconButtonProps", "AdvancedTextFieldProps", "TooltipProps", "ButtonProps", "ModalProps", "IconProps", "MobileSurfaceProps", "className"]);
    const { classes } = useStyle();
    const refs = {
        root: react_1.default.useRef(undefined)
    };
    const keys = react_1.default.useMemo(() => {
        const result = [];
        const items = [switch__, useHelperText_];
        items.forEach(item => {
            if ((0, utils_1.is)('object', item))
                Object.keys(item).filter(key => theme.breakpoints.media[key]).forEach(key => result.push(key));
        });
        return (0, utils_1.unique)(result);
    }, [switch__, useHelperText_]);
    const breakpoints = {};
    keys.forEach(key => {
        breakpoints[key] = (0, useMediaQuery_1.default)(theme.breakpoints.media[key], { element: refs.root.current });
    });
    const label = name !== undefined ? name : label_;
    const switch_ = (0, utils_2.valueBreakpoints)(switch__, true, breakpoints, theme);
    const useHelperText = (0, utils_2.valueBreakpoints)(useHelperText_, undefined, breakpoints, theme);
    const touch = (0, useMediaQuery_1.default)('(pointer: coarse)', { element: refs.root.current });
    const [value, setValue] = react_1.default.useState(() => {
        const valueResult = (valueDefault !== undefined ? valueDefault : value_) || (now && (range ? [new date_1.OnesyDate(), new date_1.OnesyDate()] : [new date_1.OnesyDate()]));
        return ((0, utils_1.is)('array', valueResult) ? valueResult : [valueResult]).filter(Boolean);
    });
    const [calendar, setCalendar] = react_1.default.useState((calendarDefault !== undefined ? calendarDefault : calendar_) || new date_1.OnesyDate());
    const [open, setOpen] = react_1.default.useState(false);
    const [mode, setMode] = react_1.default.useState((touch ? openMobile : 'select') || 'select');
    const [error, setError] = react_1.default.useState(false);
    const valueToInput = react_1.default.useCallback((valueNew = value) => {
        let result = '';
        const [from, to] = (0, utils_1.is)('array', valueNew) ? valueNew : [valueNew];
        if (!(from || to))
            return '';
        const method = (item) => `${(0, date_1.format)(item, 'DD', { l })}/${(0, date_1.format)(item, 'MM', { l })}/${(0, date_1.format)(item, 'YYYY', { l })}`;
        result += `${method(from)}`;
        if (range && to)
            result += `${exports.SEPARATOR}${method(to)}`;
        return result;
    }, [value, range]);
    const [input, setInput] = react_1.default.useState(valueToInput());
    const [inputModal, setInputModal] = react_1.default.useState(valueToInput());
    let version = version_;
    if (version === 'auto') {
        if (touch)
            version = 'mobile';
        else
            version = 'desktop';
    }
    const onUpdateValue = (valueNew_) => {
        const valueNew = (0, utils_1.is)('array', valueNew_) ? valueNew_ : [valueNew_];
        const dateNow = new date_1.OnesyDate();
        // Update value
        setValue(valueNew);
        // Update calendar
        onUpdateCalendar(valueNew[0] || dateNow);
        // Update input
        setInput(valueToInput(valueNew));
        // Update input modal
        setInputModal(valueToInput(valueNew));
    };
    const errorCheck = react_1.default.useCallback((valueNew = value) => {
        // Error
        setError((valueNew || []).some((item, index) => !valid(item)));
    }, [value]);
    // Init
    react_1.default.useEffect(() => {
        // Error
        errorCheck();
    }, []);
    // Value
    react_1.default.useEffect(() => {
        if (value_ !== undefined && value_ !== value)
            onUpdateValue((((0, utils_1.is)('array', value_) ? value_ : [value_]).filter(Boolean)));
    }, [value_]);
    // Calendar
    react_1.default.useEffect(() => {
        if (calendar_ !== undefined && calendar_ !== calendar)
            setCalendar(calendar_);
    }, [calendar_]);
    const onUpdate = react_1.default.useCallback((valueNew) => {
        // Inner update
        if (!props.hasOwnProperty('value'))
            setValue(valueNew);
        if ((0, utils_1.is)('function', onChange))
            onChange(!range ? valueNew[0] : valueNew);
    }, [onChange, range]);
    const onUpdateCalendar = react_1.default.useCallback((valueNew) => {
        // Inner update
        if (!props.hasOwnProperty('calendar'))
            setCalendar(valueNew);
        if ((0, utils_1.is)('function', onChangeCalendar))
            onChangeCalendar(valueNew);
    }, [onChangeCalendar]);
    // Update only internally, without using onChange
    // since it might be canceled
    // only use onChange on
    // input change, or ok
    const onCalendarChange = react_1.default.useCallback((valueNew_) => {
        const valueNew = (0, utils_1.is)('array', valueNew_) ? valueNew_ : [valueNew_];
        if (valueNew !== value) {
            (!actions_ ? onUpdate : setValue)(valueNew);
            // Update input modal
            setInputModal(valueToInput(valueNew));
        }
    }, [value, actions_]);
    const onCalendarChangeCalendar = react_1.default.useCallback((valueNew) => {
        if (valueNew !== calendar)
            onUpdateCalendar(valueNew);
    }, [calendar]);
    const inputToValue = react_1.default.useCallback((valueNew_ = input) => {
        let valueNew = valueNew_;
        let [from, to] = valueNew.split(exports.SEPARATOR);
        from = textToOnesyDate(from);
        if (to)
            to = textToOnesyDate(to, false);
        valueNew = [from, to].filter(Boolean);
        return valueNew;
    }, [input]);
    const onOpen = react_1.default.useCallback(() => {
        onMode();
        setOpen(!open);
    }, [open, openMobile, version]);
    const onClose = react_1.default.useCallback((event) => {
        setOpen(false);
        if ((0, utils_1.is)('function', onClose_))
            onClose_(event);
    }, [onClose_]);
    const onReset = react_1.default.useCallback(() => {
        var _a;
        let valueNew = inputToValue();
        const isValid = valueNew && ((_a = valueNew === null || valueNew === void 0 ? void 0 : valueNew[0]) === null || _a === void 0 ? void 0 : _a.valid);
        if (isValid) {
            // Update value
            onUpdate(valueNew);
            // Update calendar
            onUpdateCalendar(valueNew[0]);
            // Update input modal
            setInputModal(input);
        }
        else {
            const dateNow = new date_1.OnesyDate();
            valueNew = [];
            // Update value
            onUpdate(valueNew);
            // Update calendar
            onUpdateCalendar(dateNow);
            // Update input
            setInput(valueToInput(valueNew));
            // Update input modal
            setInputModal(valueToInput(valueNew));
        }
    }, [input]);
    const onToday = react_1.default.useCallback((event) => {
        const valueNew = [(0, date_1.startOf)(new date_1.OnesyDate(), 'day')];
        if (range)
            valueNew.push((0, date_1.endOf)(new date_1.OnesyDate(), 'day'));
        // Update value
        onUpdate(valueNew);
        // Update calendar
        onUpdateCalendar(valueNew[0]);
        // Update input
        setInput(valueToInput(valueNew));
        // Update input modal
        setInputModal(valueToInput(valueNew));
        onClose(event);
        if ((0, utils_1.is)('function', onToday_))
            onToday_(event);
    }, [input, range, onToday_]);
    const onClear = react_1.default.useCallback((event) => {
        const dateNow = new date_1.OnesyDate();
        const valueNew = [];
        // Update value
        onUpdate(valueNew);
        // Update calendar
        onUpdateCalendar(dateNow);
        // Update input
        setInput(valueToInput(valueNew));
        // Update input modal
        setInputModal(valueToInput(valueNew));
        onClose(event);
        if ((0, utils_1.is)('function', onClear_))
            onClear_(event);
    }, [onClear_]);
    const onOk = react_1.default.useCallback((event) => {
        // Error
        errorCheck();
        // Update value
        onUpdate(value);
        // Update input
        setInput(valueToInput(value));
        // Update input modal
        setInputModal(valueToInput(value));
        onClose(event);
        if ((0, utils_1.is)('function', onOk_))
            onOk_(event);
    }, [value, onOk_]);
    const onCancel = react_1.default.useCallback((event) => {
        onReset();
        onClose(event);
        if ((0, utils_1.is)('function', onCancel_))
            onCancel_(event);
    }, [input, onCancel_]);
    const valid = react_1.default.useCallback((...args) => {
        if ((0, utils_1.is)('function', valid_))
            return valid_(...args);
        const onesyDate = args[0];
        if (min || max || validate) {
            let response = true;
            if ((0, utils_1.is)('function', validate))
                response = validate(onesyDate);
            if (min !== undefined)
                response = response && (0, date_1.is)(onesyDate, 'after or same', min);
            if (max !== undefined)
                response = response && (0, date_1.is)(onesyDate, 'before or same', max);
            return response;
        }
        return true;
    }, [valid_, min, max, validate]);
    const textToOnesyDate = react_1.default.useCallback((valueNew, start = true) => {
        const [valueDay, valueMonth, valueYear] = (valueNew || '').split('/');
        const onesyDate = new date_1.OnesyDate(new Date(`${valueMonth}/${valueDay}/${valueYear}`));
        return start ? (0, date_1.startOf)(onesyDate, 'day') : (0, date_1.endOf)(onesyDate, 'day');
    }, []);
    const onInputChange = react_1.default.useCallback((valueNew_) => {
        const valueNew = inputToValue(valueNew_);
        const validValues = valueNew.every(item => item.valid);
        // Only update values if input is valid
        // format used to make the value
        if (validValues) {
            // Error
            errorCheck(valueNew);
            // Update value
            onUpdate(valueNew);
            // Update calendar
            onUpdateCalendar(valueNew[0]);
        }
        if (!valueNew_) {
            onUpdate([null, null]);
        }
        // Update input for free typing
        setInput(valueNew_);
    }, []);
    const onInputChangeModal = react_1.default.useCallback((valueNew_) => {
        const valueNew = inputToValue(valueNew_);
        const validValues = valueNew.every(item => item.valid);
        // Only update values if input is valid
        // format used to make the value
        if (validValues) {
            // Error
            errorCheck(valueNew);
            // Update value
            onUpdate(valueNew);
            // Update calendar
            onUpdateCalendar(valueNew[0]);
        }
        // Update input for free typing
        setInputModal(valueNew_);
    }, []);
    const onMode = react_1.default.useCallback((mode_ = openMobile) => {
        setMode(() => mode_);
    }, []);
    const mask = [
        { pattern: '[0-3]' },
        (item, result, valueInput) => /^(0[0-9]|1[0-9]|2[0-9]|3[0-1]).*/.test(valueInput),
        '/',
        { pattern: '[0-1]' },
        (item, result, valueInput) => /^(0[0-9]|1[0-9]|2[0-9]|3[0-1])\/(0[0-9]|1[0-2])/.test(valueInput),
        '/',
        { pattern: '[1-2]' },
        { pattern: '[0-9]' },
        { pattern: '[0-9]' },
        { pattern: '[0-9]' }
    ];
    let placeholder = `DD/MM/YYYY`;
    // range
    if (range) {
        mask.push(' ', exports.SEPARATOR_SYMBOL, ' ', ...mask);
        placeholder += `${exports.SEPARATOR}${placeholder}`;
    }
    placeholder = placeholder_ || placeholder;
    const buttonProps = Object.assign({ color: 'inherit', version: 'text', size }, ButtonProps);
    const iconButtonProps = Object.assign({ size }, IconButtonProps);
    const actions = ((0, jsx_runtime_1.jsxs)(Line, Object.assign({ direction: 'row', align: 'center', justify: 'space-between', className: (0, style_react_1.classNames)([
            (0, utils_2.staticClassName)('DatePicker', theme) && [
                'onesy-DatePicker-actions'
            ],
            classes.actions
        ]) }, { children: [(today || clear) && ((0, jsx_runtime_1.jsxs)(Line, Object.assign({ gap: 0, direction: 'row', align: 'center' }, { children: [today && ((0, jsx_runtime_1.jsx)(Button, Object.assign({ onClick: onToday }, buttonProps, { children: l('Today') }))), clear && ((0, jsx_runtime_1.jsx)(Button, Object.assign({ onClick: onClear }, buttonProps, { children: l('Clear') })))] }))), (0, jsx_runtime_1.jsxs)(Line, Object.assign({ gap: 0, direction: 'row', align: 'center' }, { children: [(0, jsx_runtime_1.jsx)(Button, Object.assign({ onClick: onCancel }, buttonProps, { children: l('Cancel') })), (0, jsx_runtime_1.jsx)(Button, Object.assign({ onClick: onOk }, buttonProps, { children: l('Ok') }))] }))] })));
    const moreProps = {};
    if (version === 'desktop') {
        moreProps.end = ((0, jsx_runtime_1.jsx)(IconButton, Object.assign({ tonal: tonal, color: color, version: 'text', onClick: onOpen, "aria-label": `${l('Choose date')}${range ? ' range' : ''}`, disabled: disabled || readOnly }, iconButtonProps, { children: (0, jsx_runtime_1.jsx)(Icon_, Object.assign({}, IconProps)) })));
    }
    if (version === 'mobile') {
        if (!(readOnly || disabled))
            moreProps.onClick = onOpen;
    }
    let textHeading = `${(0, date_1.format)(value[0], 'd', { l })}, ${(0, date_1.format)(value[0], 'MMM', { l })} ${(0, date_1.format)(value[0], 'DD', { l })}`;
    if (range) {
        textHeading = `${(0, date_1.format)(value[0], 'MMM', { l })} ${(0, date_1.format)(value[0], 'DD', { l })}${exports.SEPARATOR}${(0, date_1.format)(value[1], 'MMM', { l })} ${(0, date_1.format)(value[1], 'DD', { l })}`;
    }
    const dayNames = [l('Mo'), l('Tu'), l('We'), l('Th'), l('Fr'), l('Sa'), l('Su')];
    const mobile = ((0, jsx_runtime_1.jsxs)(Surface, Object.assign({ color: 'default', tonal: tonal, gap: 0, direction: 'column', Component: Line, className: (0, style_react_1.classNames)([
            (0, utils_2.staticClassName)('DatePicker', theme) && [
                'onesy-DatePicker-mobile'
            ],
            classes.mobile,
            fullScreen && classes.mobile_fullScreen
        ]) }, MobileSurfaceProps, { children: [(0, jsx_runtime_1.jsxs)(Line, Object.assign({ gap: 0, direction: 'column', className: (0, style_react_1.classNames)([
                    (0, utils_2.staticClassName)('DatePicker', theme) && [
                        'onesy-DatePicker-header'
                    ],
                    classes.header,
                    fullScreen && classes.header_fullScreen
                ]) }, { children: [actions_ && fullScreen && ((0, jsx_runtime_1.jsxs)(Line, Object.assign({ gap: 0, direction: 'row', align: 'center', justify: 'space-between', style: {
                            width: '100%',
                            marginBottom: 8,
                            padding: `0px ${theme.methods.space.value(1, 'px')} 0px ${theme.methods.space.value(1.5, 'px')}`
                        } }, { children: [(0, jsx_runtime_1.jsx)(IconButton, Object.assign({ color: 'inherit', version: 'text', onClick: onClose, "aria-label": l('Close') }, iconButtonProps, { children: (0, jsx_runtime_1.jsx)(IconClose, Object.assign({}, IconProps)) })), (0, jsx_runtime_1.jsx)(Button, Object.assign({ onClick: onOk }, buttonProps, { children: l('Save') }))] }))), heading_ && ((0, jsx_runtime_1.jsx)(Type, Object.assign({ version: 'l2', className: (0, style_react_1.classNames)([
                            (0, utils_2.staticClassName)('DatePicker', theme) && [
                                'onesy-DatePicker-subheading'
                            ],
                            classes.subheading,
                            fullScreen && classes.subheading_fullScreen
                        ]) }, { children: !range ? modeModalSubHeadingText : modeModalSubHeadingTextRange }))), mode === 'select' && ((0, jsx_runtime_1.jsxs)(Line, Object.assign({ direction: 'row', align: 'center', justify: 'space-between', className: (0, style_react_1.classNames)([
                            (0, utils_2.staticClassName)('DatePicker', theme) && [
                                'onesy-DatePicker-heading'
                            ],
                            classes.heading,
                            fullScreen && classes.heading_fullScreen
                        ]) }, { children: [(0, jsx_runtime_1.jsx)(Type, Object.assign({ version: 'h1' }, { children: textHeading })), switch_ && ((0, jsx_runtime_1.jsx)(Tooltip, Object.assign({ name: l('Enter date') }, { children: (0, jsx_runtime_1.jsx)(IconButton, Object.assign({ tonal: tonal, color: 'inherit', onClick: () => onMode('input'), "aria-label": l('Enter date') }, iconButtonProps, { children: (0, jsx_runtime_1.jsx)(IconEnter, Object.assign({}, IconProps)) })) })))] }))), mode === 'input' && ((0, jsx_runtime_1.jsxs)(Line, Object.assign({ direction: 'row', align: 'flex-start', justify: 'space-between', className: (0, style_react_1.classNames)([
                            (0, utils_2.staticClassName)('DatePicker', theme) && [
                                'onesy-DatePicker-heading'
                            ],
                            classes.heading,
                            fullScreen && classes.heading_fullScreen
                        ]) }, { children: [(0, jsx_runtime_1.jsx)(Type, Object.assign({ version: 'h1' }, { children: inputModeHeadingText })), switch_ && ((0, jsx_runtime_1.jsx)(Tooltip, Object.assign({ name: l('Select date') }, { children: (0, jsx_runtime_1.jsx)(IconButton, Object.assign({ tonal: tonal, color: 'inherit', onClick: () => onMode('select'), "aria-label": l('Select date') }, iconButtonProps, { children: (0, jsx_runtime_1.jsx)(Icon_, Object.assign({}, IconProps)) })) })))] })))] })), mode === 'select' && fullScreen && ((0, jsx_runtime_1.jsx)(Line, Object.assign({ gap: 0, direction: 'row', align: 'center', justify: 'space-between', className: (0, style_react_1.classNames)([
                    (0, utils_2.staticClassName)('DatePicker', theme) && [
                        'onesy-DatePicker-day-names'
                    ],
                    classes.dayNames
                ]) }, { children: dayNames.map((day, index) => ((0, jsx_runtime_1.jsx)(Line, Object.assign({ version: 'b3', direction: 'row', align: 'center', justify: 'center', Component: Type, className: (0, style_react_1.classNames)([
                        (0, utils_2.staticClassName)('DatePicker', theme) && [
                            'onesy-DatePicker-day-name'
                        ],
                        classes.dayName
                    ]) }, { children: day }), index))) }))), (0, jsx_runtime_1.jsx)(Divider, { tonal: false, className: (0, style_react_1.classNames)([
                    (0, utils_2.staticClassName)('DatePicker', theme) && [
                        'onesy-DatePicker-divider'
                    ],
                    classes.divider
                ]) }), mode === 'select' && ((0, jsx_runtime_1.jsx)(Calendar, Object.assign({ version: !fullScreen ? 'regular' : 'year', tonal: tonal, color: color, value: value, menu: 'month', menu_month_previous_unit: fullScreen ? 'year' : 'month', menu_month_next_unit: fullScreen ? 'year' : 'month', calendar: calendar, onChange: onCalendarChange, onChangeCalendar: onCalendarChangeCalendar, now: now, size: size, range: range, calendars: 1, valid: valid, min: min, max: max, validate: validate }, CalendarProps, CalendarPropsMobile, { CalendarMonthProps: Object.assign(Object.assign({ outside: false, labels: !fullScreen }, CalendarProps === null || CalendarProps === void 0 ? void 0 : CalendarProps.CalendarMonthProps), CalendarPropsMobile === null || CalendarPropsMobile === void 0 ? void 0 : CalendarPropsMobile.CalendarMonthProps), className: (0, style_react_1.classNames)([
                    (0, utils_2.staticClassName)('DatePicker', theme) && [
                        'onesy-DatePicker-calendar',
                        'onesy-DatePicker-version-mobile'
                    ],
                    CalendarProps === null || CalendarProps === void 0 ? void 0 : CalendarProps.className,
                    CalendarPropsMobile === null || CalendarPropsMobile === void 0 ? void 0 : CalendarPropsMobile.className,
                    classes.calendar,
                    classes.calendar_mobile
                ]) }))), mode === 'input' && ((0, jsx_runtime_1.jsx)(Line, Object.assign({ gap: 1.5, direction: 'row', align: 'flex-start', className: (0, style_react_1.classNames)([
                    classes.modal_input
                ]) }, { children: (0, jsx_runtime_1.jsx)(AdvancedTextField, Object.assign({ tonal: tonal, color: color, version: 'outlined', size: size, name: label, mask: mask, placeholder: placeholder, value: inputModal, onChange: onInputChangeModal, helperText: useHelperText ? placeholder : undefined, error: error, readOnly: readOnly, disabled: disabled }, AdvancedTextFieldProps, { className: (0, style_react_1.classNames)([
                        AdvancedTextFieldProps === null || AdvancedTextFieldProps === void 0 ? void 0 : AdvancedTextFieldProps.className,
                        classes.input_mobile
                    ]) })) }))), fullScreen && ((0, jsx_runtime_1.jsx)(Divider, { tonal: false, className: (0, style_react_1.classNames)([
                    (0, utils_2.staticClassName)('DatePicker', theme) && [
                        'onesy-DatePicker-divider'
                    ],
                    classes.divider
                ]) })), actions_ && react_1.default.cloneElement(actions, {
                style: {
                    paddingTop: theme.methods.space.value(1, 'px')
                }
            })] })));
    const desktop = ((0, jsx_runtime_1.jsx)(Calendar, Object.assign({ value: value, calendar: calendar, onChange: onCalendarChange, onChangeCalendar: onCalendarChangeCalendar, now: now, size: size, range: range, calendars: calendars, valid: valid, min: min, max: max, validate: validate, belowCalendars: actions_ ? actions : undefined }, CalendarProps, CalendarPropsDesktop, { className: (0, style_react_1.classNames)([
            (0, utils_2.staticClassName)('DatePicker', theme) && [
                'onesy-DatePicker-calendar',
                'onesy-DatePicker-version-desktop'
            ],
            CalendarProps === null || CalendarProps === void 0 ? void 0 : CalendarProps.className,
            CalendarPropsDesktop === null || CalendarPropsDesktop === void 0 ? void 0 : CalendarPropsDesktop.className,
            classes.calendar,
            classes.calendar_desktop
        ]) })));
    if (static_) {
        if (version === 'mobile')
            return mobile;
        if (version === 'desktop')
            return desktop;
    }
    return ((0, jsx_runtime_1.jsxs)(Line, Object.assign({ gap: 0, direction: 'column', fullWidth: fullWidth }, WrapperProps, { className: (0, style_react_1.classNames)([
            (0, utils_2.staticClassName)('DatePicker', theme) && [
                'onesy-DatePicker-root',
                `onesy-DatePicker-version-${version}`,
                `onesy-DatePicker-size-${size}`,
                WrapperProps === null || WrapperProps === void 0 ? void 0 : WrapperProps.className,
                range && `onesy-DatePicker-range`,
                readOnly && `onesy-DatePicker-read-only`,
                disabled && `onesy-DatePicker-disabled`,
                fullWidth && 'onesy-full-width'
            ],
            className,
            classes.root
        ]) }, { children: [(0, jsx_runtime_1.jsx)(AdvancedTextField, Object.assign({ rootRef: item => {
                    if (ref) {
                        if ((0, utils_1.is)('function', ref))
                            ref(item);
                        else
                            ref.current = item;
                    }
                    refs.root.current = item;
                }, tonal: tonal, color: color, version: 'outlined', size: size, name: label, mask: mask, placeholder: placeholder, value: input, onChange: onInputChange, helperText: useHelperText ? placeholder : undefined, endVerticalAlign: 'center', error: error, fullWidth: fullWidth, readOnly: readOnly, disabled: disabled }, moreProps, other, AdvancedTextFieldProps)), version === 'mobile' && ((0, jsx_runtime_1.jsx)(Modal, Object.assign({ open: open, modalWrapperSurface: false, TransitionComponent: Slide, fullScreen: fullScreen, onClose: onClose }, ModalProps, { children: mobile }))), version === 'desktop' && ((0, jsx_runtime_1.jsx)(Tooltip, Object.assign({ open: open, portal: true, anchorElement: refs.root.current, alignment: 'center', position: 'bottom', hover: false, focus: false, longPress: false, maxWidth: 'unset', noMargin: true, name: ((0, jsx_runtime_1.jsx)(ClickListener, Object.assign({ onClickOutside: onCancel, includeParentQueries: ['.onesy-Calendar-list'] }, { children: desktop }))) }, TooltipProps)))] })));
});
DatePicker.displayName = 'onesy-DatePicker';
exports.default = DatePicker;
