import React from 'react';
import { OnesyDate } from '@onesy/date';
import { IAdvancedTextField } from '../AdvancedTextField/AdvancedTextField';
import { TCalendarMonthValue } from '../CalendarMonth/CalendarMonth';
import { TCalendarUnit } from '../Calendar/Calendar';
import { TClockUnit } from '../Clock/Clock';
import { IValueBreakpoints, IElementReference, IPropsAny } from '../types';
import { ITextField } from '../TextField/TextField';
export declare type TDateTimePicker = OnesyDate;
export declare type IDateTimePicker = Omit<IAdvancedTextField, 'version' | 'onChange'> & ITextField & {
    version?: 'auto' | 'mobile' | 'desktop';
    value?: TCalendarMonthValue;
    valueDefault?: TCalendarMonthValue;
    onChange?: (value: TCalendarMonthValue) => any;
    now?: boolean;
    range?: boolean;
    static?: boolean;
    valid?: (value: OnesyDate, version: TCalendarUnit | TClockUnit) => boolean;
    validate?: (value: OnesyDate) => boolean;
    min?: OnesyDate;
    max?: OnesyDate;
    headingText?: string;
    headingTextTime?: string;
    headingTextTimeRange?: string;
    headingTextDate?: string;
    headingTextDateRange?: string;
    useHelperText?: boolean | Partial<Record<IValueBreakpoints, boolean>>;
    format?: '12' | '24';
    hour?: boolean;
    minute?: boolean;
    second?: boolean;
    today?: boolean;
    clear?: boolean;
    placeholder?: string;
    fullWidth?: boolean;
    onClose?: (event: React.MouseEvent<any>) => any;
    onCancel?: (event: React.MouseEvent<any>) => any;
    onToday?: (event: React.MouseEvent<any>) => any;
    onClear?: (event: React.MouseEvent<any>) => any;
    onOk?: (event: React.MouseEvent<any>) => any;
    Icon?: IElementReference;
    IconDate?: IElementReference;
    IconTime?: IElementReference;
    WrapperProps?: IPropsAny;
    ModalProps?: IPropsAny;
    TooltipProps?: IPropsAny;
    AdvancedTextFieldProps?: IPropsAny;
    DatePickerProps?: IPropsAny;
    TimePickerProps?: IPropsAny;
    IconButtonProps?: IPropsAny;
    ButtonProps?: IPropsAny;
    PickerProps?: IPropsAny;
    MiddleProps?: IPropsAny;
    MainProps?: IPropsAny;
    IconProps?: IPropsAny;
    ModeDesktopProps?: IPropsAny;
    ModeMobileProps?: IPropsAny;
};
declare const DateTimePicker: React.FC<IDateTimePicker>;
export default DateTimePicker;
