import React from 'react';
import { IBaseElement } from '../types';
export declare type IHTMLCanvasOnChangeValue = {
    zoom: number;
    top: number;
    left: number;
    boundaries: {
        x: number;
        y: number;
    };
    root: {
        width: number;
        height: number;
    };
};
export declare type IHTMLCanvas = Omit<IBaseElement, 'onWheel' | 'onMouseDown' | 'onTouchStart' | 'onChange'> & {
    minZoom?: number;
    maxZoom?: number;
    showGuidelinesDefault?: boolean;
    guidelines?: 'lines' | 'dots' | boolean;
    width?: number;
    height?: number;
    pre?: any;
    post?: any;
    miniMap?: boolean;
    onChange?: (value: IHTMLCanvasOnChangeValue) => any;
    onWheel?: (event: WheelEvent) => any;
    onMouseDown?: (event: MouseEvent) => any;
    onTouchStart?: (event: TouchEvent) => any;
    noActions?: boolean;
    noGuideLines?: boolean;
    noFitCenter?: boolean;
    noZoomMenu?: boolean;
    methods?: any;
    IconCenter?: any;
    ContainerProps?: any;
    IconButtonProps?: any;
};
declare const HTMLCanvas: React.FC<IHTMLCanvas>;
export default HTMLCanvas;
