import React from 'react';
import { ILine } from '../Line/Line';
import { IColor, IVersion, IElement, IPropsAny } from '../types';
export declare type ILabel = Omit<ILine, 'onChange'> & {
    colorUnchecked?: IColor;
    version?: IVersion;
    position?: 'start' | 'top' | 'bottom' | 'end';
    input?: IElement;
    label?: IElement;
    name?: IElement;
    valueDefault?: boolean;
    checkedDefault?: boolean;
    value?: any;
    checked?: any;
    onChange?: (value: boolean, event?: React.ChangeEvent<any>) => any;
    error?: boolean;
    helperText?: string;
    footer?: IElement;
    LabelProps?: IPropsAny;
    TypeProps?: IPropsAny;
    TextProps?: IPropsAny;
};
declare const Label: React.FC<ILabel>;
export default Label;
