import React from 'react';
import { IBaseElement, IPropsAny, IValueBreakpoints } from '../types';
export declare type TLineAlign = 'inherit' | 'initial' | 'flex-start' | 'center' | 'flex-end' | 'baseline' | 'stretch' | 'unset';
export declare type TLineJustify = 'inherit' | 'initial' | 'flex-start' | 'center' | 'flex-end' | 'space-around' | 'space-between' | 'space-evenly' | 'unset';
export declare type TLineDirection = 'inherit' | 'row' | 'row-reverse' | 'column' | 'column-reverse';
export declare type TLineWrap = 'inherit' | 'wrap' | 'nowrap' | 'wrap-reverse';
export declare type TLineDisplay = 'inherit' | 'flex' | 'inline-flex';
export declare type ILine = IBaseElement & {
    display?: TLineDisplay | Partial<Record<IValueBreakpoints, TLineDisplay>>;
    direction?: TLineDirection | Partial<Record<IValueBreakpoints, TLineDirection>>;
    align?: TLineAlign | Partial<Record<IValueBreakpoints, TLineAlign>>;
    justify?: TLineJustify | Partial<Record<IValueBreakpoints, TLineJustify>>;
    wrap?: TLineWrap | Partial<Record<IValueBreakpoints, TLineWrap>>;
    flex?: boolean | Partial<Record<IValueBreakpoints, boolean>>;
    flexNo?: boolean | Partial<Record<IValueBreakpoints, boolean>>;
    gap?: string | number | Partial<Record<IValueBreakpoints, string | number>>;
    rowGap?: string | number | Partial<Record<IValueBreakpoints, string | number>>;
    columnGap?: string | number | Partial<Record<IValueBreakpoints, string | number>>;
    fullWidth?: boolean | Partial<Record<IValueBreakpoints, boolean>>;
    divider?: boolean | Partial<Record<IValueBreakpoints, boolean>>;
    DividerProps?: IPropsAny;
};
declare const Line: React.FC<ILine>;
export default Line;
