import React from 'react';
import { ISurface } from '../Surface/Surface';
import { IColor, IElement, IElementReference, IPropsAny } from '../types';
export declare type IListItem = ISurface & {
    colorSelected?: IColor;
    inset?: boolean;
    primary?: IElement;
    secondary?: IElement;
    tertiary?: IElement;
    preselected?: boolean;
    selected?: boolean;
    start?: IElement;
    startAlign?: 'start' | 'center' | 'end';
    end?: IElement;
    endAlign?: 'start' | 'center' | 'end';
    noPadding?: boolean;
    href?: string;
    button?: boolean;
    shape?: 'round';
    shapePosition?: 'both' | 'start' | 'end' | 'none';
    footer?: IElement;
    tabIndex?: string | number;
    menuItem?: boolean;
    interaction?: boolean;
    noBackground?: boolean;
    noOutline?: boolean;
    value?: any;
    onClick?: (event: React.MouseEvent<any>) => any;
    onFocus?: (event: React.FocusEvent<any>) => any;
    onBlur?: (event: React.FocusEvent<any>) => any;
    onMouseEnter?: (event: React.MouseEvent<any>) => any;
    onMouseLeave?: (event: React.MouseEvent<any>) => any;
    onClose?: () => any;
    RootComponent?: IElementReference;
    WrapperProps?: IPropsAny;
    RootProps?: IPropsAny;
    InteractionProps?: IPropsAny;
    PrimaryProps?: IPropsAny;
    SecondaryProps?: IPropsAny;
    TertiaryProps?: IPropsAny;
    MainProps?: IPropsAny;
    AsideProps?: IPropsAny;
    AsideStartProps?: IPropsAny;
    AsideEndProps?: IPropsAny;
};
declare const ListItem: React.FC<IListItem>;
export default ListItem;
