import React from 'react';
import { ILinearProress } from '../LinearProgress/LinearProgress';
import { IElementReference, IPropsAny } from '../types';
export declare type IMainProgressStartArgument = {
    tonal?: boolean;
    color?: string;
};
export declare type IMainProgressValue = {
    start: (value?: IMainProgressStartArgument) => void;
    increment: () => void;
    update: (value: number) => void;
    done: () => void;
};
export declare type IMainProgress = ILinearProress & {
    min?: number;
    max?: number;
    firstIncrement?: boolean;
    incrementMin?: number;
    incrementMax?: number;
    stepMin?: number;
    stepMax?: number;
    stepInterval?: number;
    onStart?: () => any;
    onIncrement?: (value: number) => any;
    onUpdate?: (value: number) => any;
    onDone?: () => any;
    fixed?: boolean;
    position?: 'top' | 'bottom';
    TransitionComponent?: IElementReference;
    TransitionComponentProps?: IPropsAny;
};
declare const MainProgress: React.FC<IMainProgress>;
export default MainProgress;
