"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importDefault(require("react"));
const utils_1 = require("@onesy/utils");
const style_react_1 = require("@onesy/style-react");
const IconMaterialKeyboardArrowUpW100_1 = __importDefault(require("@onesy/icons-material-rounded-react/IconMaterialKeyboardArrowUpW100"));
const IconMaterialKeyboardArrowDownW100_1 = __importDefault(require("@onesy/icons-material-rounded-react/IconMaterialKeyboardArrowDownW100"));
const AdvancedTextField_1 = __importDefault(require("../AdvancedTextField"));
const IconButton_1 = __importDefault(require("../IconButton"));
const utils_2 = require("../utils");
const useStyle = (0, style_react_1.style)(theme => ({
    root: {}
}), { name: 'onesy-NumericTextField' });
const NumericTextField = react_1.default.forwardRef((props_, ref) => {
    const theme = (0, style_react_1.useOnesyTheme)();
    const props = react_1.default.useMemo(() => { var _a, _b, _c, _d, _e, _f, _g, _h; return (Object.assign(Object.assign(Object.assign({}, (_d = (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _a === void 0 ? void 0 : _a.elements) === null || _b === void 0 ? void 0 : _b.all) === null || _c === void 0 ? void 0 : _c.props) === null || _d === void 0 ? void 0 : _d.default), (_h = (_g = (_f = (_e = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _e === void 0 ? void 0 : _e.elements) === null || _f === void 0 ? void 0 : _f.onesyNumericTextField) === null || _g === void 0 ? void 0 : _g.props) === null || _h === void 0 ? void 0 : _h.default), props_)); }, [props_]);
    const AdvancedTextField = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.AdvancedTextField) || AdvancedTextField_1.default; }, [theme]);
    const IconButton = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.IconButton) || IconButton_1.default; }, [theme]);
    const { valueDefault, value: value_, onChange: onChange_, version = 'outlined', size = 'regular', min, max, increment = true, decrement = true, incrementValue = 1, decrementValue = 1, onFocus: onFocus_, onBlur: onBlur_, IconIncrement = IconMaterialKeyboardArrowUpW100_1.default, IconDecrement = IconMaterialKeyboardArrowDownW100_1.default, IconButtonProps, IconProps, className } = props, other = __rest(props, ["valueDefault", "value", "onChange", "version", "size", "min", "max", "increment", "decrement", "incrementValue", "decrementValue", "onFocus", "onBlur", "IconIncrement", "IconDecrement", "IconButtonProps", "IconProps", "className"]);
    const { classes } = useStyle();
    const [init, setInit] = react_1.default.useState(false);
    const [focus, setFocus] = react_1.default.useState(false);
    const [value, setValue] = react_1.default.useState(valueDefault !== undefined ? valueDefault : value_);
    const refs = {
        root: react_1.default.useRef(undefined),
        value: react_1.default.useRef(undefined),
        focus: react_1.default.useRef(undefined),
        min: react_1.default.useRef(undefined),
        max: react_1.default.useRef(undefined),
        onChange: react_1.default.useRef(onChange_),
        props: react_1.default.useRef(props)
    };
    refs.value.current = value;
    refs.focus.current = focus;
    refs.min.current = min;
    refs.max.current = max;
    refs.onChange.current = onChange_;
    refs.props.current = props;
    react_1.default.useEffect(() => {
        setInit(true);
    }, []);
    react_1.default.useEffect(() => {
        var _a;
        const method = (event) => {
            if (['ArrowUp', 'ArrowDown', 'End', 'Home'].includes(event.key)) {
                event.preventDefault();
            }
            switch (event.key) {
                case 'End':
                    if (refs.focus.current && refs.min.current !== undefined) {
                        let valueNew = refs.min.current;
                        if (props.thousand)
                            valueNew = (0, utils_1.numberWithCommas)(valueNew);
                        if (props.prefix !== undefined)
                            valueNew = `${props.prefix}${valueNew}`;
                        onChange(valueNew);
                    }
                    return;
                case 'Home':
                    if (refs.focus.current && refs.max.current !== undefined) {
                        let valueNew = refs.max.current;
                        if (props.thousand)
                            valueNew = (0, utils_1.numberWithCommas)(valueNew);
                        if (props.prefix !== undefined)
                            valueNew = `${props.prefix}${valueNew}`;
                        onChange(valueNew);
                    }
                    return;
                case 'ArrowUp':
                    if (refs.focus.current)
                        onIncrement();
                    return;
                case 'ArrowDown':
                    if (refs.focus.current)
                        onDecrement();
                    return;
                default:
                    break;
            }
        };
        const rootDocument = (0, utils_1.isEnvironment)('browser') ? (((_a = refs.root.current) === null || _a === void 0 ? void 0 : _a.ownerDocument) || window.document) : undefined;
        rootDocument.addEventListener('keydown', method);
        return () => {
            // Clean up
            rootDocument.removeEventListener('keydown', method);
        };
    }, []);
    react_1.default.useEffect(() => {
        if (init) {
            if (value_ !== value)
                setValue(value_);
        }
    }, [value_]);
    const onFocus = react_1.default.useCallback((event) => {
        setFocus(true);
        if ((0, utils_1.is)('function', onFocus_))
            onFocus_(event);
    }, []);
    const onBlur = react_1.default.useCallback((event) => {
        setFocus(false);
        if ((0, utils_1.is)('function', onBlur_))
            onBlur_(event);
    }, []);
    const onChange = (valueNew_) => {
        let valueNew = valueNew_;
        const min_ = refs.min.current !== undefined ? refs.min.current : Number.MIN_SAFE_INTEGER;
        const max_ = refs.max.current !== undefined ? refs.max.current : Number.MAX_SAFE_INTEGER;
        if (['', ' ', refs.props.current.prefix, `${refs.props.current.prefix} `, undefined].includes(valueNew))
            valueNew = '';
        if (!['', ' ', '+', '-', 'e', 'e+', 'e-', `${refs.props.current.prefix}+`, `${refs.props.current.prefix}-`, undefined].includes(valueNew)) {
            if (refs.props.current.prefix !== undefined)
                valueNew = valueNew.replace(refs.props.current.prefix, '');
            if (refs.props.current.thousand)
                valueNew = valueNew.replace(new RegExp(`\\${refs.props.current.thousandSeparator || ','}`, 'g'), '');
            valueNew = (0, utils_1.clamp)(+valueNew, min_, max_);
            if (refs.props.current.thousand)
                valueNew = (0, utils_1.numberWithCommas)(valueNew);
            if (refs.props.current.prefix !== undefined)
                valueNew = `${refs.props.current.prefix}${valueNew}`;
        }
        if (['+', '-', 'e', 'e+', 'e-'].includes(valueNew_) ||
            ((String(valueNew_).startsWith('-0') || String(valueNew_).includes('.')) && (0, utils_1.clamp)(+valueNew_, min_, max_) === +valueNew_))
            valueNew = valueNew_;
        // Update inner or controlled
        if (!refs.props.current.hasOwnProperty('value'))
            setValue(valueNew);
        if ((0, utils_1.is)('function', refs.onChange.current))
            refs.onChange.current(valueNew);
    };
    const onIncrement = () => {
        let valueNew = refs.value.current || '0';
        if (refs.props.current.prefix !== undefined)
            valueNew = valueNew.replace(refs.props.current.prefix, '');
        if (refs.props.current.thousand)
            valueNew = valueNew.replace(new RegExp(`\\${refs.props.current.thousandSeparator || ','}`, 'g'), '');
        const min_ = refs.min.current !== undefined ? refs.min.current : Number.MIN_SAFE_INTEGER;
        const max_ = refs.max.current !== undefined ? refs.max.current : Number.MAX_SAFE_INTEGER;
        valueNew = (0, utils_1.clamp)(+valueNew + incrementValue, min_, max_);
        if (refs.props.current.thousand)
            valueNew = (0, utils_1.numberWithCommas)(valueNew);
        if (refs.props.current.prefix !== undefined)
            valueNew = `${refs.props.current.prefix}${valueNew}`;
        // Update
        onChange(valueNew);
    };
    const onDecrement = () => {
        let valueNew = refs.value.current || '0';
        if (refs.props.current.prefix !== undefined)
            valueNew = valueNew.replace(refs.props.current.prefix, '');
        if (refs.props.current.thousand)
            valueNew = valueNew.replace(new RegExp(`\\${refs.props.current.thousandSeparator || ','}`, 'g'), '');
        const min_ = refs.min.current !== undefined ? refs.min.current : Number.MIN_SAFE_INTEGER;
        const max_ = refs.max.current !== undefined ? refs.max.current : Number.MAX_SAFE_INTEGER;
        valueNew = (0, utils_1.clamp)(+valueNew - decrementValue, min_, max_);
        if (refs.props.current.thousand)
            valueNew = (0, utils_1.numberWithCommas)(valueNew);
        if (refs.props.current.prefix !== undefined)
            valueNew = `${refs.props.current.prefix}${valueNew}`;
        // Update
        onChange(valueNew);
    };
    const end = [];
    const iconButtonProps = {
        size: 24,
        fontSize: '1.5rem'
    };
    if (decrement)
        end.push((0, jsx_runtime_1.jsx)(IconButton, Object.assign({ onClick: onDecrement }, iconButtonProps, IconButtonProps, { children: (0, jsx_runtime_1.jsx)(IconDecrement, Object.assign({}, IconProps)) })));
    if (increment)
        end.push((0, jsx_runtime_1.jsx)(IconButton, Object.assign({ onClick: onIncrement }, iconButtonProps, IconButtonProps, { children: (0, jsx_runtime_1.jsx)(IconIncrement, Object.assign({}, IconProps)) })));
    return ((0, jsx_runtime_1.jsx)(AdvancedTextField, Object.assign({ ref: item => {
            if (ref) {
                if ((0, utils_1.is)('function', ref))
                    ref(item);
                else
                    ref.current = item;
            }
            refs.root.current = item;
        }, value: value, onFocus: onFocus, onBlur: onBlur, onChange: onChange, version: version, size: size, validate: (valueNew_) => {
            if (valueNew_.startsWith(' ') || valueNew_.endsWith(' '))
                return;
            if (['', ' ', '+', '-', 'e', 'e+', 'e-', '-0', '-0.', props.prefix, `${props.prefix} `, `${props.prefix}+`, `${props.prefix}-`, undefined].includes(valueNew_))
                return true;
            let valueNew = valueNew_;
            if (props.prefix !== undefined)
                valueNew = valueNew_.replace(props.prefix, '');
            if (props.thousand)
                valueNew = valueNew.replace(new RegExp(`\\${props.thousandSeparator || ','}`, 'g'), '');
            valueNew = +valueNew;
            return (0, utils_1.is)('number', valueNew);
        }, end: end, endVerticalAlign: 'center', className: (0, style_react_1.classNames)([
            (0, utils_2.staticClassName)('NumericTextField', theme) && [
                'onesy-NumericTextField-root',
                `onesy-NumericTextField-version-${version}`,
                `onesy-NumericTextField-size-${size}`
            ],
            className,
            classes.root
        ]) }, other)));
});
NumericTextField.displayName = 'onesy-NumericTextField';
exports.default = NumericTextField;
