"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importDefault(require("react"));
const utils_1 = require("@onesy/utils");
const style_react_1 = require("@onesy/style-react");
const IconMaterialDraftW100_1 = __importDefault(require("@onesy/icons-material-rounded-react/IconMaterialDraftW100"));
const AudioPlayer_1 = __importDefault(require("../AudioPlayer"));
const Image_1 = __importDefault(require("../Image"));
const Interaction_1 = __importDefault(require("../Interaction"));
const Line_1 = __importDefault(require("../Line"));
const Section_1 = __importDefault(require("../Section/Section"));
const Type_1 = __importDefault(require("../Type"));
const VideoPlayer_1 = __importDefault(require("../VideoPlayer"));
const utils_2 = require("../utils");
const useStyle = (0, style_react_1.style)(theme => ({
    root: {},
    name: {
        wordBreak: 'break-word'
    },
    other: {
        position: 'relative',
        aspectRatio: '3 / 4',
        cursor: 'pointer',
        userSelect: 'none',
        background: theme.palette.background.secondary.tertiary,
        boxShadow: theme.shadows.values.default[1]
    },
    otherWrapper_size_small: {
        maxWidth: '74px',
        width: '90vw'
    },
    otherWrapper_size_regular: {
        maxWidth: '94px',
        width: '90vw'
    },
    otherWrapper_size_large: {
        maxWidth: '114px',
        width: '90vw'
    },
    other_size_small: {
        borderRadius: theme.methods.shape.radius.value(1)
    },
    other_size_regular: {
        borderRadius: theme.methods.shape.radius.value(2)
    },
    other_size_large: {
        borderRadius: theme.methods.shape.radius.value(3)
    }
}), { name: 'onesy-SectionMedia' });
const Element = react_1.default.forwardRef((props_, ref) => {
    const theme = (0, style_react_1.useOnesyTheme)();
    const l = theme.l;
    const props = react_1.default.useMemo(() => { var _a, _b, _c, _d, _e, _f, _g, _h; return (Object.assign(Object.assign(Object.assign({}, (_d = (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _a === void 0 ? void 0 : _a.elements) === null || _b === void 0 ? void 0 : _b.all) === null || _c === void 0 ? void 0 : _c.props) === null || _d === void 0 ? void 0 : _d.default), (_h = (_g = (_f = (_e = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _e === void 0 ? void 0 : _e.elements) === null || _f === void 0 ? void 0 : _f.onesySectionMedia) === null || _g === void 0 ? void 0 : _g.props) === null || _h === void 0 ? void 0 : _h.default), props_)); }, [props_]);
    const Line = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Line) || Line_1.default; }, [theme]);
    const Section = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Section) || Section_1.default; }, [theme]);
    const Image = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Image) || Image_1.default; }, [theme]);
    const AudioPlayer = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.AudioPlayer) || AudioPlayer_1.default; }, [theme]);
    const VideoPlayer = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.VideoPlayer) || VideoPlayer_1.default; }, [theme]);
    const Interaction = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Interaction) || Interaction_1.default; }, [theme]);
    const Type = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Type) || Type_1.default; }, [theme]);
    const { value, size = 'regular', name, IconDocument = IconMaterialDraftW100_1.default, MediaProps, ImageProps, AudioProps, VideoProps, OtherProps, className } = props, other = __rest(props, ["value", "size", "name", "IconDocument", "MediaProps", "ImageProps", "AudioProps", "VideoProps", "OtherProps", "className"]);
    const { classes } = useStyle();
    const refs = {
        root: react_1.default.useRef(undefined)
    };
    const onOpenMedia = react_1.default.useCallback((media) => {
        window.open(media.url || media.urlSmall, 'blank_');
    }, []);
    let element;
    if (value) {
        const mime = value.mime;
        if (mime === null || mime === void 0 ? void 0 : mime.includes('image'))
            element = ((0, jsx_runtime_1.jsx)(Image, Object.assign({ src: (value === null || value === void 0 ? void 0 : value.url) || (value === null || value === void 0 ? void 0 : value.urlSmall) || ((0, utils_1.is)('string', value) ? value : ''), maxWidth: 'rg', fullWidth: true }, MediaProps, ImageProps, { className: (0, style_react_1.classNames)([
                    (0, utils_2.staticClassName)('SectionMedia', theme) && [
                        'onesy-SectionMedia-item',
                        'onesy-SectionMedia-item-image'
                    ],
                    MediaProps === null || MediaProps === void 0 ? void 0 : MediaProps.className,
                    ImageProps === null || ImageProps === void 0 ? void 0 : ImageProps.className
                ]) })));
        else if (mime === null || mime === void 0 ? void 0 : mime.includes('audio'))
            element = ((0, jsx_runtime_1.jsx)(AudioPlayer, Object.assign({ size: size }, value, MediaProps, AudioProps, { className: (0, style_react_1.classNames)([
                    (0, utils_2.staticClassName)('SectionMedia', theme) && [
                        'onesy-SectionMedia-item',
                        'onesy-SectionMedia-item-audio'
                    ],
                    MediaProps === null || MediaProps === void 0 ? void 0 : MediaProps.className,
                    AudioProps === null || AudioProps === void 0 ? void 0 : AudioProps.className
                ]) })));
        else if (mime === null || mime === void 0 ? void 0 : mime.includes('video'))
            element = ((0, jsx_runtime_1.jsx)(VideoPlayer, Object.assign({ size: size }, value, MediaProps, VideoProps, { className: (0, style_react_1.classNames)([
                    (0, utils_2.staticClassName)('SectionMedia', theme) && [
                        'onesy-SectionMedia-item',
                        'onesy-SectionMedia-item-video'
                    ],
                    MediaProps === null || MediaProps === void 0 ? void 0 : MediaProps.className,
                    VideoProps === null || VideoProps === void 0 ? void 0 : VideoProps.className
                ]) })));
        else
            element = ((0, jsx_runtime_1.jsx)(Line, Object.assign({ gap: 1, className: (0, style_react_1.classNames)([
                    (0, utils_2.staticClassName)('SectionMedia', theme) && [
                        'onesy-SectionMedia-wrapper',
                        'onesy-SectionMedia-wrapper-other'
                    ],
                    classes.wrapper,
                    classes[`otherWrapper_size_${size}`]
                ]) }, { children: (0, jsx_runtime_1.jsxs)(Line, Object.assign({ align: 'center', justify: 'center', onClick: () => onOpenMedia(value), fullWidth: true }, MediaProps, OtherProps, { className: (0, style_react_1.classNames)([
                        (0, utils_2.staticClassName)('SectionMedia', theme) && [
                            'onesy-SectionMedia-item',
                            'onesy-SectionMedia-item-other'
                        ],
                        MediaProps === null || MediaProps === void 0 ? void 0 : MediaProps.className,
                        OtherProps === null || OtherProps === void 0 ? void 0 : OtherProps.className,
                        classes.other,
                        classes[`other_size_${size}`]
                    ]) }, { children: [(0, jsx_runtime_1.jsx)(Interaction, {}), (0, jsx_runtime_1.jsx)(IconDocument, { size: size === 'large' ? 44 : size === 'regular' ? 34 : 24 })] })) })));
    }
    return ((0, jsx_runtime_1.jsx)(Section, Object.assign({ ref: (item) => {
            if (ref) {
                if ((0, utils_1.is)('function', ref))
                    ref(item);
                else
                    ref.current = item;
            }
            refs.root.current = item;
        }, maxWidth: 'small', align: 'center', className: (0, style_react_1.classNames)([
            (0, utils_2.staticClassName)('SectionMedia', theme) && [
                'onesy-SectionMedia-root',
                `onesy-SectionMedia-size-${size}`
            ],
            className,
            classes.root
        ]) }, other, { children: (0, jsx_runtime_1.jsxs)(Line, Object.assign({ align: 'center', fullWidth: true }, { children: [element, name && ((0, jsx_runtime_1.jsx)(Type, Object.assign({ version: size === 'large' ? 't1' : size === 'regular' ? 't2' : 't3', align: 'center', fullWidth: true, className: (0, style_react_1.classNames)([
                        (0, utils_2.staticClassName)('SectionMedia', theme) && [
                            'onesy-SectionMedia-name'
                        ],
                        classes.name
                    ]) }, { children: (0, utils_1.cleanValue)((value === null || value === void 0 ? void 0 : value.name) || l('No name'), { capitalize: true }) })))] })) })));
});
Element.displayName = 'onesy-SectionMedia';
exports.default = Element;
