import React from 'react';
import { IBaseElement, IElement, IPropsAny, ISizeAny } from '../types';
export declare type TSliderValue = number | Array<number>;
export declare type ISlider = Omit<IBaseElement, 'onChange'> & {
    value?: TSliderValue;
    valueDefault?: TSliderValue;
    onChange?: (value: TSliderValue) => any;
    orientation?: 'vertical' | 'horizontal';
    marks?: Array<{
        value?: number;
        label?: IElement;
    }>;
    precision?: number;
    min?: number;
    max?: number;
    tooltip?: 'always' | boolean;
    labels?: boolean;
    onlyMarks?: boolean;
    labelTooltipResolve?: (value: number) => IElement;
    iconButtonPositionResolve?: (value: number, normalized: number, size: ISizeAny) => string;
    noTrack?: boolean;
    noButtons?: boolean;
    square?: boolean;
    inverted?: boolean;
    icon?: any;
    IconButtonProps?: IPropsAny;
    LabelProps?: IPropsAny;
    TooltipProps?: IPropsAny;
};
declare const Slider: React.FC<ISlider>;
export default Slider;
