import React from 'react';
import { ISurface } from '../Surface/Surface';
import { IElement, IElementReference, IPropsAny } from '../types';
export declare type ISnackbar = ISurface & {
    open?: boolean;
    primary?: IElement;
    end?: IElement;
    position?: 'top' | 'bottom';
    alignment?: 'start' | 'left' | 'center' | 'right' | 'end';
    autoHide?: boolean;
    autoHideDuration?: number;
    resumeFromStart?: boolean;
    fixed?: boolean;
    closeButton?: boolean;
    onMouseEnter?: (event: React.MouseEvent<any>) => any;
    onMouseLeave?: (event: React.MouseEvent<any>) => any;
    onClose?: () => any;
    IconClose?: any;
    TransitionComponent?: IElementReference;
    IconProps?: IPropsAny;
    IconButtonProps?: IPropsAny;
    TransitionComponentProps?: IPropsAny;
};
declare const Snackbar: React.FC<ISnackbar>;
export default Snackbar;
