import React from 'react';
import { TLineAlign, TLineJustify } from '../Line/Line';
import { IBaseElement, IPropsAny } from '../types';
export declare type ITableCellSort = 'asc' | 'desc';
export declare type ITableCell = IBaseElement & {
    sort?: boolean;
    sortedByDefault?: ITableCellSort;
    sortedBy?: ITableCellSort;
    onSort?: (value: ITableCellSort) => any;
    position?: 'head' | 'body';
    align?: TLineAlign;
    justify?: TLineJustify;
    noWeight?: boolean;
    sticky?: boolean;
    stickyPosition?: 'left' | 'right';
    stickyOffset?: number;
    IconArrow?: any;
    IconButtonSortProps?: any;
    TypeProps?: any;
    DividerProps?: IPropsAny;
};
declare const TableCell: React.FC<ITableCell>;
export default TableCell;
