import React from 'react';
import { IBaseElement, IElement, IPropsAny, IElementReference, IVersion } from '../types';
export declare type ITree = Omit<IBaseElement, 'onChange'> & {
    open?: boolean;
    openDefault?: boolean;
    version?: IVersion;
    onChange?: (value: boolean) => any;
    selected?: boolean;
    line?: boolean;
    indicator?: boolean;
    arrow?: boolean;
    checkbox?: boolean;
    indicatorPosition?: 'start' | 'end';
    level?: number;
    icon?: IElement;
    iconOpen?: IElement;
    start?: IElement;
    middle?: IElement;
    end?: IElement;
    button?: boolean;
    noTransition?: boolean;
    noExpand?: boolean;
    noPadding?: boolean;
    parent?: HTMLElement;
    parentDisabled?: boolean;
    ExpandProps?: IPropsAny;
    MainProps?: IPropsAny;
    StartProps?: IPropsAny;
    MiddleProps?: IPropsAny;
    EndProps?: IPropsAny;
    IndicatorProps?: IPropsAny;
    TransitionComponentProps?: IPropsAny;
    TreeProps?: IPropsAny;
    IconArrow?: IElementReference;
    TransitionComponent?: IElementReference;
};
declare const Tree: React.FC<ITree>;
export default Tree;
