import React from 'react';
import { ILine } from '../Line/Line';
import { IElementReference, IPropsAny } from '../types';
export declare type IVideoPlayer = ILine & {
    name?: string;
    src?: string;
    mime?: string;
    meta?: any;
    versions?: any;
    thumbnails?: any;
    duration?: number;
    start?: any;
    end?: any;
    startControls?: any;
    endControls?: any;
    startButtons?: any;
    endButtons?: any;
    startEnd?: any;
    endEnd?: any;
    startButtonsEnd?: any;
    endButtonsEnd?: any;
    forward?: boolean;
    backward?: boolean;
    settings?: boolean;
    quality?: boolean;
    playbackSpeed?: boolean;
    pictureInPicture?: boolean;
    fullScreen?: boolean;
    startMediaSessionOnPlay?: boolean;
    IconPlay?: IElementReference;
    IconPause?: IElementReference;
    IconForward?: IElementReference;
    IconBackward?: IElementReference;
    IconVolume?: IElementReference;
    IconVolumeMuted?: IElementReference;
    IconBack?: IElementReference;
    IconSettings?: IElementReference;
    IconQuality?: IElementReference;
    IconPlaybackSpeed?: IElementReference;
    IconPictureInPicture?: IElementReference;
    IconFullScreen?: IElementReference;
    IconFullScreenExit?: IElementReference;
    PlayButtonProps?: IPropsAny;
    ForwardButtonProps?: IPropsAny;
    BackwardButtonProps?: IPropsAny;
    VolumeButtonProps?: IPropsAny;
    IconButtonProps?: IPropsAny;
    TypeProps?: IPropsAny;
    TimelineProps?: IPropsAny;
    VolumeProps?: IPropsAny;
    SliderProps?: IPropsAny;
    SettingsButtonProps?: IPropsAny;
    SettingsMenuProps?: IPropsAny;
    QualityButtonProps?: IPropsAny;
    PictureInPictureButtonProps?: IPropsAny;
    FullScreenButtonProps?: IPropsAny;
};
declare const VideoPlayer: React.FC<IVideoPlayer>;
export default VideoPlayer;
