import React from 'react';
import { OnesyDate } from '@onesy/date';
import { ISurface } from '../Surface/Surface';
import { IElement, IPropsAny } from '../types';
export declare type IWatch = Omit<ISurface, 'version'> & {
    version?: 'regular' | 'analog' | 'modern' | 'minimal';
    start?: boolean;
    timeVisible?: boolean;
    timeOfDayVisible?: boolean;
    dateVisible?: boolean;
    timeFormatString?: string;
    dateFormatString?: string;
    renderTime?: (value: OnesyDate) => IElement;
    renderDate?: (value: OnesyDate) => IElement;
    shadow?: boolean;
    AnalogProps?: IPropsAny;
    RegularProps?: IPropsAny;
    MinimalProps?: IPropsAny;
    ModernProps?: IPropsAny;
};
declare const Watch: React.FC<IWatch>;
export default Watch;
