import React from 'react';
import { IBaseElement } from '../types';
export declare type IWhiteboardAction = {
    v: 'a' | 'r';
    i: IWhiteboardItem | IWhiteboardItem[];
};
export declare type IWhiteboardTool = 'pen' | 'eraser' | 'pan' | 'zoom' | 'select' | 'circle' | 'rectangle' | 'triangle' | 'line' | 'line-arrow' | 'text' | 'image';
export declare type IWhiteboardValue = IWhiteboardItem[];
export declare type IWhiteboard = Omit<IBaseElement, 'onChange'> & {
    valueDefault?: IWhiteboardValue;
    onChange?: (value: IWhiteboardValue) => any;
    minZoom?: number;
    maxZoom?: number;
    grid?: boolean;
    settings?: any;
};
export declare type IWhiteboardItem = {
    i: string;
    v?: 'dl' | 'dp' | 'oc' | 'oe' | 'or' | 'os' | 'ot' | 'ote' | 'ol' | 'oa' | 'i' | 't';
    p: number[];
    c?: number[];
    ar?: number[];
    s?: {
        lineCap?: string;
        lineJoin?: string;
        lineWidth?: number;
        strokeStyle?: string;
        globalAlpha?: number;
        [p: string]: any;
    };
    se?: boolean;
    a: number;
};
declare const Whiteboard: React.FC<IWhiteboard>;
export default Whiteboard;
