import React from 'react';
import { ILine } from '../Line/Line';
import { IElement, IPropsAny } from '../types';
export declare type IWindowSplit = Omit<ILine, 'onChange'> & {
    valueDefault?: number;
    value?: number;
    onChange?: (value: number) => any;
    padding?: number;
    paddingStart?: number;
    paddingEnd?: number;
    iconButton?: IElement;
    orientation?: 'vertical' | 'horizontal';
    noKeyboard?: boolean;
    noDivider?: boolean;
    focus?: boolean;
    onFocus?: (event: React.FocusEvent<any>) => any;
    onBlur?: (event: React.FocusEvent<any>) => any;
    onMouseEnter?: (event: React.MouseEvent<any>) => any;
    onMouseLeave?: (event: React.MouseEvent<any>) => any;
    iconButtonComponent?: IElement;
    iconOrientationHorizontal?: IElement;
    iconOrientationVertical?: IElement;
    IconButtonProps?: IPropsAny;
    DividerProps?: IPropsAny;
    SeparatorProps?: IPropsAny;
};
declare const WindowSplit: React.FC<IWindowSplit>;
export default WindowSplit;
