import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
const _excluded = ["valueInputDefault", "size", "className", "children"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
import React from 'react';
import { classNames, style as styleMethod, useOnesyTheme } from '@onesy/style-react';
import AutoCompleteElement from '../AutoComplete';
import { currencies, staticClassName } from '../utils';
const useStyle = styleMethod(theme => ({
  root: {}
}), {
  name: 'onesy-AutoCompleteCurrency'
});
const AutoCompleteCurrency = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useOnesyTheme();
  const l = theme.l;
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.onesyAutoCompleteCurrency?.props?.default), props_), [props_]);
  const AutoComplete = React.useMemo(() => theme?.elements?.AutoComplete || AutoCompleteElement, [theme]);
  const {
      valueInputDefault: valueInputDefault_,
      size = 'regular',
      className,
      children
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();

  // {
  //   symbol: '€',
  //   name: 'Euro',
  //   symbol_native: '€',
  //   'decimal_digits': 2,
  //   rounding: 0,
  //   code: 'EUR',
  //   name_plural: 'euros'
  // }
  const options = React.useMemo(() => {
    return [{
      name: l('No currency'),
      value: ''
    }, ...currencies.map(item => ({
      name: `${item.code} ${item.name} (${item.symbol})`,
      value: item.code
    }))];
  }, [currencies]);
  const valueInputDefault = React.useMemo(() => {
    return valueInputDefault_ !== undefined ? valueInputDefault_ : options.find(item => item.value === (other.value !== undefined ? other.value : other.valueDefault))?.name;
  }, []);
  return /*#__PURE__*/React.createElement(AutoComplete, _extends({
    ref: ref,
    valueInputDefault: valueInputDefault,
    options: options,
    size: size,
    className: classNames([staticClassName('AutoCompleteCurrency', theme) && ['onesy-AutoCompleteCurrency-root', `onesy-AutoCompleteCurrency-size-${size}`], className, classes.root])
  }, other));
});
AutoCompleteCurrency.displayName = 'onesy-AutoCompleteCurrency';
export default AutoCompleteCurrency;