import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
const _excluded = ["size", "maxWidth", "actions", "start", "end", "Component", "style", "className", "children"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
import React from 'react';
import { classNames, style as styleMethod, useOnesyTheme } from '@onesy/style-react';
import ListItemElement from '../ListItem';
import GridElement from '../Grid';
import LineElement from '../Line';
import { staticClassName } from '../utils';
const useStyle = styleMethod(theme => ({
  root: {
    width: '100%',
    '&.onesy-ListItem-root': {
      padding: '0px'
    }
  },
  listItem: {
    margin: '0 auto'
  },
  // maxWidth
  maxWidth_xxs: {
    maxWidth: '320px'
  },
  maxWidth_xs: {
    maxWidth: '400px'
  },
  maxWidth_sm: {
    maxWidth: '600px'
  },
  maxWidth_rg: {
    maxWidth: '960px'
  },
  maxWidth_lg: {
    maxWidth: '1240px'
  },
  maxWidth_xl: {
    maxWidth: '1920px'
  },
  maxWidth_unset: {
    maxWidth: 'unset'
  }
}), {
  name: 'onesy-Banner'
});
const Banner = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useOnesyTheme();
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.onesyBanner?.props?.default), props_), [props_]);
  const Line = React.useMemo(() => theme?.elements?.Line || LineElement, [theme]);
  const ListItem = React.useMemo(() => theme?.elements?.ListItem || ListItemElement, [theme]);
  const Grid = React.useMemo(() => theme?.elements?.Grid || GridElement, [theme]);
  const {
      size = 'regular',
      maxWidth,
      actions,
      start,
      end,
      Component = 'div',
      style,
      className,
      children
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();
  const styles = {
    root: {}
  };
  if (actions) {
    other.line = true;
    other.RootProps = {};
    other.RootProps.values = {
      md: 7
    };
    other.footer = /*#__PURE__*/React.createElement(Grid, {
      Component: Line,
      RootProps: {
        gap: 1,
        direction: 'row'
      },
      justify: "flex-end",
      align: "flex-end",
      values: {
        md: 2
      },
      offsets: {
        md: 1
      }
    }, actions);
  }
  if (!classes[`maxWidth_${maxWidth}`]) styles.root.maxWidth = maxWidth;
  return /*#__PURE__*/React.createElement(Component, {
    ref: ref,
    role: "alert",
    className: classNames([staticClassName('Banner', theme) && ['onesy-Banner-root', `onesy-Banner-size-${size}`], className, classes.root]),
    style: _objectSpread(_objectSpread({}, styles.root), style)
  }, start, /*#__PURE__*/React.createElement(ListItem, _extends({
    size: size,
    Component: Grid,
    RootComponent: Grid,
    PrimaryProps: {
      version: 'b2'
    },
    className: classNames([staticClassName('Banner', theme) && ['onesy-Banner-list-item'], classes.listItem, classes[`maxWidth_${maxWidth}`]])
  }, other), children), end);
});
Banner.displayName = 'onesy-Banner';
export default Banner;