import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
const _excluded = ["className"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
import React from 'react';
import { classNames, style as styleMethod, useOnesyTheme } from '@onesy/style-react';
import NavigationDrawerElement from '../NavigationDrawer';
import { staticClassName } from '../utils';
const useStyle = styleMethod(theme => ({
  root: {
    '&.onesy-Modal-root .onesy-Modal-surface': {
      paddingTop: theme.methods.space.value(6.25, 'px'),
      maxWidth: '640px',
      '&:before': {
        content: "''",
        position: 'absolute',
        background: 'currentColor',
        height: '4px',
        width: '32px',
        top: '23px',
        left: '50%',
        transform: 'translateX(-50%)',
        borderRadius: theme.methods.shape.radius.value(0.5, 'px'),
        opacity: '0.4'
      }
    },
    '@media only screen and (min-width: 640px)': {
      '&.onesy-Modal-root .onesy-Modal-surface': {
        marginTop: '72px',
        marginInline: '56px'
      }
    }
  }
}), {
  name: 'onesy-BottomSheet'
});
const BottomSheet = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useOnesyTheme();
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.onesyBottomSheet?.props?.default), props_), [props_]);
  const NavigationDrawer = React.useMemo(() => theme?.elements?.NavigationDrawer || NavigationDrawerElement, [theme]);
  const {
      className
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();
  return /*#__PURE__*/React.createElement(NavigationDrawer, _extends({
    ref: ref,
    direction: "bottom",
    className: classNames([staticClassName('BottomSheet', theme) && ['onesy-BottomSheet-root'], className, classes.root])
  }, other));
});
BottomSheet.displayName = 'onesy-BottomSheet';
export default BottomSheet;