import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
const _excluded = ["max", "separator", "renderMore", "IconMore", "Component", "MoreProps", "className", "children"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
import React from 'react';
import { clamp, is, unique } from '@onesy/utils';
import { classNames, style as styleMethod, useOnesyTheme } from '@onesy/style-react';
import IconMaterialNavigateNext from '@onesy/icons-material-rounded-react/IconMaterialNavigateNextW100';
import IconMaterialMoreHoriz from '@onesy/icons-material-rounded-react/IconMaterialMoreHorizW100';
import LineElement from '../Line';
import TypeElement from '../Type';
import IconButtonElement from '../IconButton';
import useMediaQuery from '../useMediaQuery';
import { staticClassName, valueBreakpoints } from '../utils';
const useStyle = styleMethod(theme => ({
  root: {
    margin: 0,
    padding: 0
  },
  expandMore: {
    '&.onesy-IconButton-root': {
      padding: '0',
      width: 'unset',
      height: '100%',
      borderRadius: theme.methods.shape.radius.value(0.25, 'px')
    }
  }
}), {
  name: 'onesy-Breadcrumbs'
});
const Breadcrumbs = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useOnesyTheme();
  const l = theme.l;
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.onesyBreadcrumbs?.props?.default), props_), [props_]);
  const Line = React.useMemo(() => theme?.elements?.Line || LineElement, [theme]);
  const Type = React.useMemo(() => theme?.elements?.Type || TypeElement, [theme]);
  const IconButton = React.useMemo(() => theme?.elements?.IconButton || IconButtonElement, [theme]);
  const {
      max: max_,
      separator = /*#__PURE__*/React.createElement(IconMaterialNavigateNext, {
        size: "small"
      }),
      renderMore,
      IconMore = IconMaterialMoreHoriz,
      Component = 'nav',
      MoreProps,
      className,
      children: children_
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();
  const refs = {
    root: React.useRef(undefined)
  };
  const keys = React.useMemo(() => {
    const result = [];
    const items = [max_];
    items.forEach(item => {
      if (is('object', item)) Object.keys(item).filter(key => theme.breakpoints.media[key]).forEach(key => result.push(key));
    });
    return unique(result);
  }, [max_]);
  const breakpoints = {};
  keys.forEach(key => {
    breakpoints[key] = useMediaQuery(theme.breakpoints.media[key], {
      element: refs.root.current
    });
  });
  let max = valueBreakpoints(max_, undefined, breakpoints, theme);
  max = clamp(max, 2);
  const onExpandMore = () => {
    setChildren(resolve(children_, false));
  };
  const resolve = function () {
    let items_ = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : children_;
    let maxValue = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : max;
    let items = React.Children.toArray(items_).filter(Boolean);
    if (maxValue !== undefined && maxValue >= 2 && maxValue < items.length) {
      const start = [];
      const end = [];
      for (let i = 1; i <= maxValue; i++) {
        // start
        if (i % 2 > 0) start.push(items[Math.floor(i / 2)]);
        // end
        else end.unshift(items[items.length - i / 2]);
      }
      items = [...start, is('function', renderMore) ? renderMore(onExpandMore) : /*#__PURE__*/React.createElement(IconButton, _extends({
        color: "default",
        size: "small",
        onClick: onExpandMore,
        "aria-label": l('Expand more path')
      }, MoreProps, {
        className: classNames([staticClassName('Breadcrumbs', theme) && ['onesy-Breadcrumbs-expand-more'], MoreProps?.className, classes.expandMore])
      }), /*#__PURE__*/React.createElement(IconMore, {
        size: "small"
      })), ...end];
    }
    return items;
  };
  const [init, setInit] = React.useState(false);
  const [children, setChildren] = React.useState(resolve);
  React.useEffect(() => {
    setInit(true);
  }, []);
  React.useEffect(() => {
    if (init) setChildren(resolve(children_));
  }, [children_, max]);
  const Separator = is('simple', separator) ? /*#__PURE__*/React.createElement(Type, {
    version: "b2",
    "aria-hidden": true,
    Component: "span"
  }, separator) : /*#__PURE__*/React.cloneElement(separator, {
    'aria-hidden': true
  });
  const childrenToUse = children.flatMap((item, index) => [item, index !== children.length - 1 && Separator].filter(Boolean));
  return /*#__PURE__*/React.createElement(Line, _extends({
    ref: item => {
      if (ref) {
        if (is('function', ref)) ref(item);else ref.current = item;
      }
      refs.root.current = item;
    },
    gap: 1,
    direction: "row",
    align: "center",
    wrap: "wrap",
    "aria-label": l('Breadcrumb'),
    Component: Component
  }, other, {
    className: classNames([staticClassName('Breadcrumbs', theme) && ['onesy-Breadcrumbs-root'], className, classes.root])
  }), childrenToUse.map((item, index) => {
    const itemProps = {};
    if (index === childrenToUse.length - 1) {
      itemProps['aria-current'] = 'page';
    }
    if (is('simple', item)) {
      return /*#__PURE__*/React.createElement(Type, _extends({
        key: index,
        version: "b2",
        Component: "span"
      }, itemProps, {
        className: classNames([staticClassName('Breadcrumbs', theme) && ['onesy-Breadcrumbs-item'], classes.item])
      }), item);
    }
    return /*#__PURE__*/React.cloneElement(item, _objectSpread({
      key: index,
      className: classNames([staticClassName('Breadcrumbs', theme) && ['onesy-Breadcrumbs-item'], item?.props?.className, classes.item])
    }, itemProps));
  }));
});
Breadcrumbs.displayName = 'onesy-Breadcrumbs';
export default Breadcrumbs;