import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
const _excluded = ["tonal", "color", "version", "input", "filter", "selected", "start", "focus", "noCheckIcon", "onClick", "onRemove", "onSelected", "onUnselected", "className", "children"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
import React from 'react';
import { is } from '@onesy/utils';
import { classNames, style as styleMethod, useOnesyTheme } from '@onesy/style-react';
import IconMaterialClose from '@onesy/icons-material-rounded-react/IconMaterialCloseW100';
import ButtonElement from '../Button';
import { IconDoneAnimated } from '../Buttons/Buttons';
import { staticClassName } from '../utils';
const useStyle = styleMethod(theme => ({
  root: {
    '&.onesy-Button-root': {
      maxWidth: '100%'
    },
    '& .onesy-Icon-root': {
      pointerEvents: 'unset !important'
    }
  }
}), {
  name: 'onesy-Chip'
});
const Chip = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useOnesyTheme();
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.onesyChip?.props?.default), props_), [props_]);
  const Button = React.useMemo(() => theme?.elements?.Button || ButtonElement, [theme]);
  const {
      tonal = false,
      color = props.version === 'filled' ? 'inverted' : 'default',
      version = 'outlined',
      input,
      filter,
      selected: selected_,
      start,
      focus,
      noCheckIcon,
      onClick,
      onRemove,
      onSelected,
      onUnselected,
      className,
      children: children_
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();
  const [preSelected, setPreSelected] = React.useState(false);
  const [selected, setSelected] = React.useState(selected_);
  const children = children_;
  React.useEffect(() => {
    if (selected !== selected_) setSelected(selected_);
  }, [selected_]);
  const OtherProps = {};
  if (input) {
    OtherProps.end = /*#__PURE__*/React.createElement(IconMaterialClose, {
      onClick: event => {
        if (is('function', onRemove)) onRemove(event);
      }
    });
  }
  const onSelect = () => {
    if (filter) {
      if (start) {
        if (selected) {
          setSelected(false);
          if (is('function', onUnselected)) onUnselected();
        } else {
          setSelected(true);
          if (is('function', onSelected)) onSelected();
        }
      } else {
        // Unselect
        if (selected) {
          setPreSelected(false);
          if (is('function', onUnselected)) onUnselected();
        } else {
          setPreSelected(true);
          setSelected(true);
          if (is('function', onSelected)) onSelected();
        }
      }
    }
  };
  const updateSelected = () => {
    if (filter) {
      setSelected(false);
    }
  };
  return /*#__PURE__*/React.createElement(Button, _extends({
    ref: ref,
    tonal: tonal,
    version: version,
    color: color || (tonal ? 'neutral' : 'default'),
    onClick: event => {
      onSelect();

      // Invoke items on click method
      if (is('function', onClick)) onClick(event);
    },
    start: start
  }, !noCheckIcon && start && selected ? {
    start: /*#__PURE__*/React.createElement(IconDoneAnimated, {
      simple: true,
      in: true,
      add: true
    })
  } : {}, !noCheckIcon && !start && (selected || preSelected) ? {
    start: /*#__PURE__*/React.createElement(IconDoneAnimated, {
      in: start ? selected : preSelected,
      onExited: () => updateSelected(),
      add: true
    })
  } : {}, {
    focus: focus,
    selected: selected,
    chip: true,
    className: classNames([staticClassName('Chip', theme) && ['onesy-Chip-root', selected && `onesy-Chip-selected`], className, classes.root])
  }, other, OtherProps), children);
});
Chip.displayName = 'onesy-Chip';
export default Chip;