import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
const _excluded = ["values", "className"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
import React from 'react';
import { clamp, is } from '@onesy/utils';
import { classNames, style as styleMethod, useOnesyTheme } from '@onesy/style-react';
import ChartElement from '../Chart';
import ColumnChartItemElement from '../ColumnChartItem';
import { staticClassName } from '../utils';
const useStyle = styleMethod(theme => ({
  root: {}
}), {
  name: 'onesy-ColumnChart'
});
const ColumnChart = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useOnesyTheme();
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.onesyColumnChart?.props?.default), props_), [props_]);
  const Chart = React.useMemo(() => theme?.elements?.Chart || ChartElement, [theme]);
  const ColumnChartItem = React.useMemo(() => theme?.elements?.ColumnChartItem || ColumnChartItemElement, [theme]);
  const {
      values,
      className
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();
  const [rects, setRects] = React.useState();
  const onUpdateRects = valueNew => {
    setRects(valueNew);
  };
  const wrapperRect = rects?.wrapper;
  const widthItem = wrapperRect ? clamp(wrapperRect?.width / (values.length * 2), undefined, 40) : undefined;
  return /*#__PURE__*/React.createElement(Chart, _extends({
    ref: ref,
    values: values,
    pointsVisibility: "hidden",
    elementTooltip: true,
    onUpdateRects: onUpdateRects,
    className: classNames([staticClassName('ColumnChart', theme) && ['onesy-ColumnChart-root'], className, classes.root])
  }, other), is('array', values) && values.map((item, index) => /*#__PURE__*/React.createElement(ColumnChartItem, _extends({
    key: index,
    width: widthItem
  }, item))));
});
ColumnChart.displayName = 'onesy-ColumnChart';
export default ColumnChart;