import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
const _excluded = ["name", "description", "size", "startActions", "endActions", "onReject", "onAllow", "in", "TransitionElement", "noTransition", "MainProps", "NameProps", "DescriptionProps", "ButtonProps", "RejectButtonProps", "AllowButtonProps", "TransitionProps", "className", "children"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
import React from 'react';
import { is } from '@onesy/utils';
import { classNames, style as styleMethod, useOnesyTheme } from '@onesy/style-react';
import ButtonElement from '../Button';
import TypeElement from '../Type';
import SurfaceElement from '../Surface';
import SlideElement from '../Slide';
import LineElement from '../Line';
import { staticClassName } from '../utils';
const useStyle = styleMethod(theme => ({
  root: {
    position: 'fixed',
    left: '0',
    bottom: '0',
    zIndex: theme.z_index.modal,
    boxShadow: '0px 4px 32px 0px rgba(0,0,0,0.014)'
  },
  size_small: {
    padding: '12px 16px'
  },
  size_regular: {
    padding: '20px 18px'
  },
  size_large: {
    padding: '28px 20px'
  },
  main: {
    maxWidth: '1100px'
  }
}), {
  name: 'onesy-CookieBanner'
});
const CookieBanner = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useOnesyTheme();
  const l = theme.l;
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.onesyBanner?.props?.default), props_), [props_]);
  const Line = React.useMemo(() => theme?.elements?.Line || LineElement, [theme]);
  const Slide = React.useMemo(() => theme?.elements?.Slide || SlideElement, [theme]);
  const Surface = React.useMemo(() => theme?.elements?.Surface || SurfaceElement, [theme]);
  const Type = React.useMemo(() => theme?.elements?.Type || TypeElement, [theme]);
  const Button = React.useMemo(() => theme?.elements?.Button || ButtonElement, [theme]);
  const {
      name,
      description,
      size = 'regular',
      startActions,
      endActions,
      onReject,
      onAllow,
      in: inProp,
      TransitionElement: TransitionElementProps = Slide,
      noTransition,
      MainProps,
      NameProps,
      DescriptionProps,
      ButtonProps,
      RejectButtonProps,
      AllowButtonProps,
      TransitionProps,
      className,
      children
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();
  const TransitionElement = noTransition ? React.Fragment : TransitionElementProps;
  const WrapperProps = noTransition ? undefined : _objectSpread(_objectSpread({}, TransitionProps), {}, {
    in: inProp
  });
  const buttonProps = _objectSpread({
    size
  }, ButtonProps);
  return /*#__PURE__*/React.createElement(TransitionElement, WrapperProps, /*#__PURE__*/React.createElement(Line, _extends({
    ref: ref,
    gap: 1.5,
    align: "center",
    fullWidth: true,
    Component: Surface,
    color: "default",
    role: "region",
    "aria-label": l('Cookie Banner'),
    className: classNames([staticClassName('CookieBanner', theme) && ['onesy-CookieBanner-root', `onesy-CookieBanner-size-${size}`], className, classes.root, classes[`size_${size}`]])
  }, other), /*#__PURE__*/React.createElement(Line, _extends({
    gap: 1.5,
    direction: "row",
    wrap: "wrap",
    align: "center",
    justify: "space-between",
    fullWidth: true
  }, MainProps, {
    className: classNames([staticClassName('CookieBanner', theme) && ['onesy-CookieBanner-main'], MainProps?.className, classes.main])
  }), /*#__PURE__*/React.createElement(Line, {
    gap: 0.25
  }, is('string', name) ? /*#__PURE__*/React.createElement(Type, _extends({
    version: size === 'large' ? 't1' : size === 'regular' ? 't2' : 't3',
    weight: 500
  }, NameProps), name) : name, is('string', description) ? /*#__PURE__*/React.createElement(Type, _extends({
    version: size === 'large' ? 'b1' : size === 'regular' ? 'b2' : 'b3'
  }, DescriptionProps), description) : description), /*#__PURE__*/React.createElement(Line, {
    gap: 1,
    direction: "row",
    align: "center"
  }, startActions, /*#__PURE__*/React.createElement(Button, _extends({
    onClick: onReject,
    color: "default"
  }, buttonProps, RejectButtonProps), l('Reject All')), /*#__PURE__*/React.createElement(Button, _extends({
    onClick: onAllow,
    color: "primary",
    version: "filled"
  }, buttonProps, AllowButtonProps), l('Accept All')), endActions))));
});
CookieBanner.displayName = 'onesy-CookieBanner';
export default CookieBanner;