import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
const _excluded = ["tonal", "color", "version", "start", "files", "multiple", "max", "allowedTypes", "dropText", "valueDefault", "value", "onChange", "IconStart", "onFocus", "onBlur", "onDrop", "onDragOver", "onDragEnter", "onDragLeave", "disabled", "children", "className"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
import React from 'react';
import { is, isEnvironment } from '@onesy/utils';
import { classNames, style as styleMethod, useOnesyTheme } from '@onesy/style-react';
import IconMaterialCloudUpload from '@onesy/icons-material-rounded-react/IconMaterialCloudUploadW100';
import FileChooseElement from '../FileChoose';
import SurfaceElement from '../Surface';
import TypeElement from '../Type';
import LineElement from '../Line';
import InteractionElement from '../Interaction';
import { staticClassName } from '../utils';
const useStyle = styleMethod(theme => ({
  root: {},
  wrapperText: {
    width: '100%',
    height: '100%',
    userSelect: 'none',
    pointerEvents: 'none'
  },
  wrapper: {
    width: '100%'
  },
  label: {
    position: 'relative',
    '&.onesy-Surface-root': {
      width: '100%',
      height: '174px',
      outlineStyle: 'dashed',
      outlineWidth: '3px',
      borderRadius: theme.methods.shape.radius.value('lg', 'px'),
      cursor: 'pointer'
    }
  },
  disabled: {
    opacity: '0.4',
    cursor: 'default',
    pointerEvents: 'none'
  }
}), {
  name: 'onesy-DropZone'
});
const DropZone = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useOnesyTheme();
  const l = theme.l;
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.onesyDropZone?.props?.default), props_), [props_]);
  const Line = React.useMemo(() => theme?.elements?.Line || LineElement, [theme]);
  const FileChoose = React.useMemo(() => theme?.elements?.FileChoose || FileChooseElement, [theme]);
  const Surface = React.useMemo(() => theme?.elements?.Surface || SurfaceElement, [theme]);
  const Type = React.useMemo(() => theme?.elements?.Type || TypeElement, [theme]);
  const Interaction = React.useMemo(() => theme?.elements?.Interaction || InteractionElement, [theme]);
  const {
      tonal = true,
      color = 'default',
      version,
      start,
      files,
      multiple,
      max,
      allowedTypes,
      dropText = l('Drop files here'),
      valueDefault,
      value: value_,
      onChange: onChange_,
      IconStart = IconMaterialCloudUpload,
      onFocus: onFocus_,
      onBlur: onBlur_,
      onDrop: onDrop_,
      onDragOver: onDragOver_,
      onDragEnter: onDragEnter_,
      onDragLeave: onDragLeave_,
      disabled,
      children,
      className
    } = props,
    otherProps = _objectWithoutProperties(props, _excluded);
  const other = otherProps;
  const {
    classes
  } = useStyle();
  const [init, setInit] = React.useState(false);
  const [focus, setFocus] = React.useState(false);
  const [dragOver, setDragOver] = React.useState(false);
  const [value, setValue] = React.useState(valueDefault !== undefined ? valueDefault : value_);
  const refs = {
    root: React.useRef(undefined),
    value: React.useRef(undefined),
    label: React.useRef(undefined),
    input: React.useRef(undefined),
    focus: React.useRef(undefined),
    allowedTypes: React.useRef(undefined),
    max: React.useRef(undefined)
  };
  refs.value.current = value;
  refs.focus.current = focus;
  refs.max.current = max;
  refs.allowedTypes.current = allowedTypes;
  React.useEffect(() => {
    const method = event => {
      switch (event.key) {
        case 'Enter':
          if (refs.focus.current) refs.input.current.click();
          break;
        default:
          break;
      }
    };
    const rootDocument = isEnvironment('browser') ? refs.root.current?.ownerDocument || window.document : undefined;
    rootDocument.addEventListener('keydown', method);
    setInit(true);
    return () => {
      rootDocument.removeEventListener('keydown', method);
    };
  }, []);
  React.useEffect(() => {
    if (init) {
      if (value_ !== refs.value.current) setValue(value_);
    }
  }, [value_]);
  const onChange = React.useCallback(valueNew_ => {
    let valueNew = valueNew_;

    // Allowed types
    if (is('array', refs.allowedTypes.current)) valueNew = valueNew.map(item => refs.allowedTypes.current.includes(item.name));

    // Max
    if (refs.max.current) valueNew = valueNew.slice(0, refs.max.current);
    if (!props.hasOwnProperty('value')) setValue(valueNew);
    if (is('function', onChange_)) onChange_(valueNew);
  }, []);
  const onFocus = React.useCallback(event => {
    setFocus(true);
    if (is('function', onFocus_)) onFocus_(event);
  }, [onFocus_]);
  const onBlur = React.useCallback(event => {
    setFocus(false);
    if (is('function', onBlur_)) onBlur_(event);
  }, [onBlur_]);
  const onDrop = React.useCallback(event => {
    event.preventDefault();
    setDragOver(false);
    const valueNew = Array.from(event.dataTransfer.files);
    onChange(valueNew);
    if (is('function', onDrop_)) onDrop_(event);
  }, []);
  const onDragEnter = React.useCallback(event => {
    event.preventDefault();
    setDragOver(true);
    if (is('function', onDragEnter_)) onDragEnter_(event);
  }, []);
  const onDragLeave = React.useCallback(event => {
    event.preventDefault();
    setDragOver(false);
    if (is('function', onDragLeave_)) onDragLeave_(event);
  }, []);
  const onDragOver = React.useCallback(event => {
    event.preventDefault();
    if (is('function', onDragOver_)) onDragOver_(event);
  }, []);
  other.onDrop = onDrop;
  other.onDragEnter = onDragEnter;
  other.onDragLeave = onDragLeave;
  other.onDragOver = onDragOver;
  const custom = !!children;
  let WrapperProps = {};
  let ComponentProps = {};
  if (files) {
    WrapperProps = _objectSpread(_objectSpread({}, WrapperProps), other);
  } else {
    ComponentProps = _objectSpread(_objectSpread({}, ComponentProps), other);
  }
  return /*#__PURE__*/React.createElement(FileChoose, {
    ref: item => {
      if (ref) {
        if (is('function', ref)) ref(item);else ref.current = item;
      }
      refs.root.current = item;
    },
    inputRef: refs.input,
    valueDefault: valueDefault,
    value: value,
    tonal: tonal,
    color: color,
    version: "text",
    files: files,
    multiple: multiple,
    max: max,
    allowedTypes: allowedTypes,
    start: undefined,
    onChange: onChange,
    Component: Surface,
    className: classNames([staticClassName('DropZone', theme) && ['onesy-DropZone-root'], className, classes.root, disabled && classes.disabled]),
    ComponentProps: _objectSpread(_objectSpread({
      tabIndex: 0,
      onFocus,
      onBlur
    }, ComponentProps), {}, {
      className: classNames([staticClassName('DropZone', theme) && ['onesy-DropZone-label'], ComponentProps?.className, !custom && classes.label])
    }),
    WrapperProps: _objectSpread(_objectSpread({}, WrapperProps), {}, {
      className: classNames([staticClassName('DropZone', theme) && ['onesy-DropZone-wrapper'], WrapperProps?.className, classes.wrapper])
    })
  }, /*#__PURE__*/React.createElement(Interaction, {
    pulse: focus || dragOver
  }), children, !custom && /*#__PURE__*/React.createElement(Line, {
    direction: "row",
    align: "center",
    justify: "center",
    className: classNames([staticClassName('DropZone', theme) && ['onesy-DropZone-wrapper-text'], classes.wrapperText])
  }, /*#__PURE__*/React.createElement(IconStart, null), /*#__PURE__*/React.createElement(Type, {
    version: "t1"
  }, dropText)));
});
DropZone.displayName = 'onesy-DropZone';
export default DropZone;