import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
const _excluded = ["name", "description", "start", "end", "row", "footer", "responsive", "Component", "HeaderProps", "MainProps", "TextProps", "AsideProps", "StartProps", "EndProps", "className", "children"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
import React from 'react';
import { is } from '@onesy/utils';
import { style as styleMethod, classNames, useOnesyTheme } from '@onesy/style-react';
import LineElement from '../Line';
import TypeElement from '../Type';
import { staticClassName } from '../utils';
const useStyle = styleMethod(theme => ({
  root: {},
  aside: {
    flex: '0 0 auto'
  },
  row: {
    '& > *': {
      flex: '1 1 auto'
    }

    // '& .onesy-TextField-root, & .onesy-TextField-wrapper': {
    //   width: '100%'
    // }
  },
  footer: {
    marginTop: '8px'
  }
}), {
  name: 'onesy-FormRow'
});
const FormRow = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useOnesyTheme();
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.onesyFormRow?.props?.default), props_), [props_]);
  const Line = React.useMemo(() => theme?.elements?.Line || LineElement, [theme]);
  const Type = React.useMemo(() => theme?.elements?.Type || TypeElement, [theme]);
  const {
      name,
      description,
      start,
      end,
      row,
      footer,
      responsive = true,
      Component = Line,
      HeaderProps,
      MainProps,
      TextProps,
      AsideProps,
      StartProps,
      EndProps,
      className,
      children
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();
  const text = name || description;
  const actions = start || end;
  const header = text || actions;
  let justify = 'unset';
  if (start && end && !text) justify = 'space-between';
  if (!start && !text && end) justify = 'flex-end';
  return /*#__PURE__*/React.createElement(Component, _extends({
    ref: ref,
    gap: 1,
    direction: "column",
    justify: "unset",
    align: "unset",
    fullWidth: true,
    className: classNames([staticClassName('FormRow', theme) && ['onesy-FormRow-root'], className, classes.root])
  }, other), header && /*#__PURE__*/React.createElement(Line, _extends({
    direction: "row",
    align: "center",
    justify: justify,
    fullWidth: true
  }, HeaderProps), start && /*#__PURE__*/React.createElement(Line, _extends({}, AsideProps, StartProps, {
    className: classNames([AsideProps?.className, StartProps?.className, classes.aside])
  }), start), text && /*#__PURE__*/React.createElement(Line, _extends({
    gap: 0.5,
    direction: "column",
    flex: true
  }, TextProps), name && (is('string', name) ? /*#__PURE__*/React.createElement(Type, {
    version: "l2"
  }, name) : name), description && (is('string', description) ? /*#__PURE__*/React.createElement(Type, {
    version: "b3"
  }, description) : description)), end && /*#__PURE__*/React.createElement(Line, _extends({
    gap: 0,
    direction: "row",
    align: "center"
  }, AsideProps, EndProps, {
    className: classNames([AsideProps?.className, EndProps?.className, classes.aside])
  }), end)), /*#__PURE__*/React.createElement(Line, _extends({
    gap: 2,
    direction: row ? responsive ? {
      default: 'row',
      1400: 'column'
    } : 'row' : 'column',
    fullWidth: true,
    className: classNames([staticClassName('FormRow', theme) && ['onesy-FormRow-main'], MainProps?.className, row && classes.row])
  }, MainProps), children), footer && /*#__PURE__*/React.createElement(Line, {
    direction: "row",
    justify: "flex-end",
    fullWidth: true,
    className: classes.footer
  }, footer));
});
FormRow.displayName = 'onesy-FormRow';
export default FormRow;