import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
const _excluded = ["id", "src", "WrapperProps", "className", "children"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
import React from 'react';
import ReactDOM from 'react-dom';
import { is, isEnvironment } from '@onesy/utils';
import { classNames, style as styleMethod, useOnesyTheme } from '@onesy/style-react';
import LineElement from '../Line';
import { importIframeStyles, staticClassName } from '../utils';
const useStyle = styleMethod(theme => ({
  root: {
    width: '100%',
    height: '100%'
  },
  hidden: {
    height: 0,
    width: 0,
    opacity: 0,
    visibility: 'hidden'
  }
}), {
  name: 'onesy-IFrame'
});
const IFrame = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useOnesyTheme();
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.onesyIFrame?.props?.default), props_), [props_]);
  const Line = React.useMemo(() => theme?.elements?.Line || LineElement, [theme]);
  const {
      id,
      src,
      WrapperProps,
      className,
      children
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();
  const [init, setInit] = React.useState(false);
  const [show, setShow] = React.useState(false);
  const [root, setRoot] = React.useState();
  const refs = {
    root: React.useRef(root)
  };
  refs.root.current = root;
  const iframeDocument = refs.root.current?.contentWindow?.document;
  const iframeBody = refs.root.current?.contentWindow?.document.body;
  const refresh = React.useCallback(() => {
    if (iframeDocument) {
      const rootDocument = isEnvironment('browser') ? refs.root.current?.ownerDocument || window.document : undefined;

      // Add iframe ref to iframe document
      iframeDocument.iframe = refs.root.current;
      iframeDocument.iframeWindow = refs.root.current?.contentWindow;

      // Head
      iframeDocument.head?.replaceWith(rootDocument.createElement('head'));
      importIframeStyles(iframeDocument);

      // Default
      const styleDefault = rootDocument.createElement('style');
      styleDefault.innerHTML = `
        body {
          background-color: transparent;
          padding: 0px;
        }

        body::-webkit-scrollbar {
          height: 0px;
          width: 0px;
        }
      `;
      iframeDocument.head?.append(styleDefault);

      // Body
      if (iframeBody) iframeBody.dir = rootDocument.body.dir;
    }
  }, [iframeDocument]);
  React.useEffect(() => {
    if (init && !show) setTimeout(() => {
      refresh();
      setShow(true);
    }, 740);
  }, [init]);
  React.useEffect(() => {
    refresh();
    if (!init) setInit(true);
  }, [id, refs.root.current, children, theme]);
  return /*#__PURE__*/React.createElement(Line, _extends({
    gap: 0,
    flex: true,
    fullWidth: true
  }, WrapperProps), /*#__PURE__*/React.createElement(Line, {
    className: classes.hidden
  }, children), src && /*#__PURE__*/React.createElement("iframe", _extends({
    ref: item => {
      if (ref) {
        if (is('function', ref)) ref(item);else ref.current = item;
      }
      setRoot(item);
    },
    title: id,
    src: src,
    className: classNames([staticClassName('IFrame', theme) && ['onesy-IFrame-root'], className, classes.root])
  }, other), init && iframeBody && /*#__PURE__*/ReactDOM.createPortal(/*#__PURE__*/React.cloneElement(children, {
    iframeRef: refs.root.current,
    style: _objectSpread(_objectSpread({}, children?.props.style), {}, {
      transition: theme.methods.transitions.make('opacity')
    }, show ? {
      opacity: 1
    } : {
      opacity: 0
    })
  }), iframeBody)));
});
IFrame.displayName = 'onesy-IFrame';
export default IFrame;