import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
const _excluded = ["rows", "columns", "version", "Component", "className", "style", "children"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
import React from 'react';
import { is, unique } from '@onesy/utils';
import { classNames, style as styleMethod, useOnesyTheme } from '@onesy/style-react';
import LineElement from '../Line';
import useMediaQuery from '../useMediaQuery';
import { valueBreakpoints, staticClassName } from '../utils';
const useStyle = styleMethod(theme => ({
  root: {
    position: 'relative',
    '& img': {
      display: 'block',
      width: '100%',
      height: 'auto',
      objectFit: 'cover',
      flex: '1 1 auto'
    }
  },
  version_masonry: {
    display: 'block',
    height: 'auto'
  }
}), {
  name: 'onesy-ImageListItem'
});
const ImageListItem = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useOnesyTheme();
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.onesyImageListItem?.props?.default), props_), [props_]);
  const Line = React.useMemo(() => theme?.elements?.Line || LineElement, [theme]);
  const {
      rows: rows_,
      columns: columns_,
      version = 'standard',
      Component = 'li',
      className,
      style,
      children: children_
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();
  const refs = {
    root: React.useRef(undefined)
  };
  const keys = React.useMemo(() => {
    const result = [];
    const items = [rows_, columns_];
    items.forEach(item => {
      if (is('object', item)) Object.keys(item).filter(key => theme.breakpoints.media[key]).forEach(key => result.push(key));
    });
    return unique(result);
  }, [rows_, columns_]);
  const breakpoints = {};
  keys.forEach(key => {
    breakpoints[key] = useMediaQuery(theme.breakpoints.media[key], {
      element: refs.root.current
    });
  });
  const rows = valueBreakpoints(rows_, 1, breakpoints, theme);
  const columns = valueBreakpoints(columns_, 1, breakpoints, theme);
  const styles = {
    root: {}
  };
  if (version !== 'masonry') {
    styles.root.gridRowEnd = `span ${rows}`;
    styles.root.gridColumnEnd = `span ${columns}`;
  }
  const children = React.Children.toArray(children_);
  if (children.length > 1) other.justify = 'flex-end';
  return /*#__PURE__*/React.createElement(Line, _extends({
    ref: item => {
      if (ref) {
        if (is('function', ref)) ref(item);else ref.current = item;
      }
      refs.root.current = item;
    },
    gap: 0,
    direction: "column",
    align: "center",
    justify: "center",
    Component: Component,
    className: classNames([staticClassName('ImageListItem', theme) && ['onesy-ImageListItem-root'], className, classes.root, classes[`version_${version}`]]),
    style: _objectSpread(_objectSpread({}, styles.root), style)
  }, other), children);
});
ImageListItem.displayName = 'onesy-ImageListItem';
export default ImageListItem;