import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
const _excluded = ["name", "title", "render", "Icon", "IconProps", "IconButtonProps", "TitleProps", "ContainerProps", "TooltipProps", "className", "children"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
import React from 'react';
import { is } from '@onesy/utils';
import { classNames, style, useOnesyTheme } from '@onesy/style-react';
import IconMaterialInfo from '@onesy/icons-material-rounded-react/IconMaterialInfoW100';
import IconButtonElement from '../IconButton';
import LineElement from '../Line';
import MenuElement from '../Menu';
import TooltipElement from '../Tooltip';
import TypeElement from '../Type';
import { staticClassName } from '../utils';
const useStyle = style(theme => ({
  root: {},
  menu: {
    width: '100vw',
    maxWidth: '195px',
    background: theme.palette.light ? theme.palette.background.default.primary : theme.palette.background.default.quaternary,
    borderRadius: theme.methods.shape.radius.value(2),
    boxShadow: theme.shadows.values.default[1],
    padding: '16px',
    '& .onesy-Type-root': {
      whiteSpace: 'normal'
    }
  }
}), {
  name: 'onesy-Info'
});
const Info = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useOnesyTheme();
  const l = theme.l;
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.onesyInfo?.props?.default), props_), [props_]);
  const IconButton = React.useMemo(() => theme?.elements?.IconButton || IconButtonElement, [theme]);
  const Line = React.useMemo(() => theme?.elements?.Line || LineElement, [theme]);
  const Menu = React.useMemo(() => theme?.elements?.Menu || MenuElement, [theme]);
  const Tooltip = React.useMemo(() => theme?.elements?.Tooltip || TooltipElement, [theme]);
  const Type = React.useMemo(() => theme?.elements?.Type || TypeElement, [theme]);
  const {
      name,
      title,
      render,
      Icon = IconMaterialInfo,
      IconProps,
      IconButtonProps,
      TitleProps,
      ContainerProps,
      TooltipProps,
      className,
      children
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();
  return /*#__PURE__*/React.createElement(Menu, _extends({
    ref: ref,
    alignment: "center",
    name: is('function', render) ? render() : /*#__PURE__*/React.createElement(Line, {
      gap: 1,
      fullWidth: true,
      className: classNames([staticClassName('Info', theme) && ['onesy-Info-menu'], classes.menu])
    }, /*#__PURE__*/React.createElement(Line, _extends({
      gap: 1,
      fullWidth: true
    }, ContainerProps), /*#__PURE__*/React.createElement(Type, _extends({
      version: "l2"
    }, TitleProps), title), children)),
    className: classNames([staticClassName('Info', theme) && ['onesy-Info-root'], className, classes.root])
  }, other), /*#__PURE__*/React.createElement("span", null, /*#__PURE__*/React.createElement(Tooltip, _extends({
    name: name !== undefined ? name : l('Info')
  }, TooltipProps), /*#__PURE__*/React.createElement(IconButton, IconButtonProps, /*#__PURE__*/React.createElement(Icon, IconProps)))));
});
Info.displayName = 'onesy-Info';
export default Info;