import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
const _excluded = ["values", "smooth", "smoothRatio", "className"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
import React from 'react';
import { is } from '@onesy/utils';
import { classNames, style as styleMethod, useOnesyTheme } from '@onesy/style-react';
import ChartElement from '../Chart';
import LineChartItemElement from '../LineChartItem';
import { staticClassName } from '../utils';
const useStyle = styleMethod(theme => ({
  root: {}
}), {
  name: 'onesy-LineChart'
});
const LineChart = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useOnesyTheme();
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.onesyLineChart?.props?.default), props_), [props_]);
  const Chart = React.useMemo(() => theme?.elements?.Chart || ChartElement, [theme]);
  const LineChartItem = React.useMemo(() => theme?.elements?.LineChartItem || LineChartItemElement, [theme]);
  const {
      values,
      smooth,
      smoothRatio,
      className
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();
  return /*#__PURE__*/React.createElement(Chart, _extends({
    ref: ref,
    values: values,
    className: classNames([staticClassName('LineChart', theme) && ['onesy-LineChart-root'], className, classes.root])
  }, other), is('array', values) && values.map((item, index) => /*#__PURE__*/React.createElement(LineChartItem, _extends({
    key: index,
    smooth: smooth,
    smoothRatio: smoothRatio
  }, item))));
});
LineChart.displayName = 'onesy-LineChart';
export default LineChart;