import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
const _excluded = ["values", "separator", "ItemProps", "SeparatorProps", "className", "children"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
import React from 'react';
import { is } from '@onesy/utils';
import { classNames, style as styleMethod, useOnesyTheme } from '@onesy/style-react';
import TypeElement from '../Type';
import LineElement from '../Line';
import { staticClassName } from '../utils';
const useStyle = styleMethod(theme => ({
  root: {
    overflow: 'auto hidden',
    '& > *': {
      flex: '0 0 auto'
    }
  }
}), {
  name: 'onesy-Meta'
});
const Meta = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useOnesyTheme();
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.onesyMeta?.props?.default), props_), [props_]);
  const Line = React.useMemo(() => theme?.elements?.Line || LineElement, [theme]);
  const Type = React.useMemo(() => theme?.elements?.Type || TypeElement, [theme]);
  const {
      values: values_ = [],
      separator: separator_ = '•',
      ItemProps,
      SeparatorProps,
      className,
      children
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();
  const separator = is('string', separator_) ? /*#__PURE__*/React.createElement(Type, _extends({
    version: "b3",
    priority: "secondary"
  }, SeparatorProps), separator_) : separator_;
  const getItem = (item, index) => {
    if (is('simple', item)) return /*#__PURE__*/React.createElement(Type, {
      key: index,
      version: "b3",
      priority: "secondary"
    }, item);
    return /*#__PURE__*/React.cloneElement(item, {
      key: index
    });
  };
  const values = values_?.filter(Boolean)?.flatMap((item, index) => !index ? getItem(item, index) : [separator, getItem(item, index)]);
  return /*#__PURE__*/React.createElement(Line, _extends({
    ref: ref,
    gap: 1,
    direction: "row",
    align: "center",
    justify: "flex-start",
    className: classNames([staticClassName('Meta', theme) && ['onesy-Meta-root'], className, classes.root])
  }, other), values);
});
Meta.displayName = 'onesy-Meta';
export default Meta;