import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
const _excluded = ["menuItems", "Icon", "IconButtonProps", "className"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
import React from 'react';
import { classNames, style as styleMethod, useOnesyTheme } from '@onesy/style-react';
import IconMaterialMoreVert from '@onesy/icons-material-rounded-react/IconMaterialMoreVertW100';
import IconButtonElement from '../IconButton';
import MenuElement from '../Menu/Menu';
import { staticClassName } from '../utils';
const useStyle = styleMethod(theme => ({
  root: {},
  iconButton: {
    flex: '0 0 auto'
  }
}), {
  name: 'onesy-MoreOptions'
});
const MoreOptions = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useOnesyTheme();
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.onesyMoreOptions?.props?.default), props_), [props_]);
  const Menu = React.useMemo(() => theme?.elements?.Menu || MenuElement, [theme]);
  const IconButton = React.useMemo(() => theme?.elements?.IconButton || IconButtonElement, [theme]);
  const {
      menuItems,
      Icon: Icon_ = IconMaterialMoreVert,
      IconButtonProps,
      className
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();
  const onClick = React.useCallback(event => {
    //  event.stopPropagation();
  }, []);
  return /*#__PURE__*/React.createElement(Menu, _extends({
    alignment: "center",
    onClick: onClick,
    menuItems: menuItems
  }, other, {
    ListProps: _objectSpread({
      color: 'themed',
      size: 'small'
    }, other?.ListProps),
    className: classNames([staticClassName('MoreOptions', theme) && ['onesy-MoreOptions-root'], className, classes.root])
  }), /*#__PURE__*/React.createElement(IconButton, _extends({
    color: "inherit",
    size: "small",
    disabled: !menuItems?.length,
    onClick: onClick
  }, IconButtonProps, {
    className: classNames([staticClassName('MoreOptions', theme) && ['onesy-MoreOptions-icon-button'], IconButtonProps?.className, classes.iconButton])
  }), /*#__PURE__*/React.createElement(Icon_, null)));
});
MoreOptions.displayName = 'onesy-MoreOptions';
export default MoreOptions;