import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
const _excluded = ["color", "version", "width", "height", "animation", "text", "Component", "className", "style", "children"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
import React from 'react';
import { classNames, style as styleMethod, useOnesyTheme } from '@onesy/style-react';
import SurfaceElement from '../Surface';
import { staticClassName } from '../utils';
const useStyle = styleMethod(theme => ({
  '@keyframes move': {
    '100%': {
      transform: 'translateX(100%)'
    }
  },
  '@keyframes pulse': {
    '0%': {
      opacity: '1'
    },
    '50%': {
      opacity: '0.4'
    },
    '100%': {
      opacity: '1'
    }
  },
  '@keyframes pulseDark': {
    '0%': {
      opacity: '1'
    },
    '50%': {
      opacity: '0.7'
    },
    '100%': {
      opacity: '1'
    }
  },
  root: {
    position: 'relative',
    userSelect: 'none',
    overflow: 'hidden'
  },
  wrapper: {
    opacity: theme.palette.light ? '0.07' : '0.14',
    background: 'currentColor',
    width: '100%',
    height: '100%'
  },
  animation_wave: {
    '&::before': {
      content: "''",
      position: 'absolute',
      inset: '0',
      background: `linear-gradient(90deg, transparent, ${theme.methods.palette.color.colorToRgb(theme.palette.text.default.primary, 4)}, transparent)`,
      transform: 'translateX(-100%)',
      animation: '$move 2.4s infinite'
    }
  },
  animation_pulse: {
    animation: `$pulse${theme.palette.light ? '' : 'Dark'} 2.4s 0.4s infinite`
  },
  version_circle: {
    borderRadius: theme.methods.shape.radius.value(40, 'px')
  },
  version_rounded: {
    borderRadius: theme.methods.shape.radius.value(1, 'px')
  },
  version_rectangle: {
    borderRadius: '0px'
  },
  text: {
    height: '1em'
  },
  children: {
    visibility: 'hidden'
  }
}), {
  name: 'onesy-Placeholder'
});
const Placeholder = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useOnesyTheme();
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.onesyPlaceholder?.props?.default), props_), [props_]);
  const Surface = React.useMemo(() => theme?.elements?.Surface || SurfaceElement, [theme]);
  const {
      color = 'default',
      version = 'rounded',
      width,
      height,
      animation = 'pulse',
      text,
      Component = 'div',
      className,
      style,
      children
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();
  const styles = {
    root: {}
  };
  if (width !== undefined) styles.root.width = width;
  if (height !== undefined) styles.root.height = height;
  return /*#__PURE__*/React.createElement(Component, _extends({
    ref: ref,
    className: classNames([staticClassName('Placeholder', theme) && [`onesy-Placeholder-root`], className, classes.root, classes[`version_${version}`], animation && animation && classes[`animation_${animation}`], text && classes.text]),
    style: _objectSpread(_objectSpread({}, style), styles.root)
  }, other), /*#__PURE__*/React.createElement(Surface, {
    version: "text",
    tonal: false,
    color: color,
    className: classNames([staticClassName('Placeholder', theme) && [`onesy-Placeholder-wrapper`], classes.wrapper])
  }, children && /*#__PURE__*/React.createElement("div", {
    className: classNames([staticClassName('Placeholder', theme) && [`onesy-Placeholder-children`], classes.children])
  }, children)));
});
Placeholder.displayName = 'onesy-Placeholder';
export default Placeholder;