import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
const _excluded = ["version", "size", "values", "onlyWithValues", "maxWidth", "PropertyProps", "className", "children"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
import React from 'react';
import { classNames, style as styleMethod, useOnesyTheme } from '@onesy/style-react';
import LineElement from '../Line/Line';
import PropertyElement from '../Property';
import { staticClassName } from '../utils';
const useStyle = styleMethod(theme => ({
  root: {},
  maxWidth_extra_small: {
    maxWidth: '240px'
  },
  maxWidth_small: {
    maxWidth: '340px'
  },
  maxWidth_regular: {
    maxWidth: '440px'
  },
  maxWidth_large: {
    maxWidth: '740px'
  },
  maxWidth_extra_large: {
    maxWidth: '1024px'
  },
  maxWidth_extra_extra_large: {
    maxWidth: '1440px'
  }
}), {
  name: 'onesy-Properties'
});
const Properties = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useOnesyTheme();
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.onesyProperties?.props?.default), props_), [props_]);
  const Line = React.useMemo(() => theme?.elements?.Line || LineElement, [theme]);
  const Property = React.useMemo(() => theme?.elements?.Property || PropertyElement, [theme]);
  const {
      version = 'row-20',
      size = 'regular',
      values = [],
      onlyWithValues = true,
      maxWidth,
      PropertyProps,
      className,
      children
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();
  if (!values?.length || onlyWithValues && !values.every(item => item.value !== undefined)) return null;
  return /*#__PURE__*/React.createElement(Line, _extends({
    ref: ref,
    gap: size === 'large' ? 1.5 : size === 'regular' ? 1 : 0.5,
    rowGap: size === 'large' ? 1.5 : size === 'regular' ? 1 : 0.5,
    fullWidth: true,
    className: classNames([staticClassName('Properties', theme) && ['onesy-Properties-root', `onesy-Properties-version-${version}`, `onesy-Properties-size-${size}`], className, classes.root, maxWidth && classes[`maxWidth_${maxWidth}`]])
  }, other), values?.filter(Boolean)?.map((item, index) => /*#__PURE__*/React.createElement(Property, _extends({
    key: index,
    version: version,
    size: size,
    name: item.name,
    value: item.value,
    separator: item.separator
  }, PropertyProps, item.props))));
});
Properties.displayName = 'onesy-Properties';
export default Properties;