import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
const _excluded = ["open", "name", "label", "tooltipOpen", "closeOnClick", "render", "onBlur", "onFocus", "Icon", "TooltipProps", "Component", "className", "children"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
import React from 'react';
import { is } from '@onesy/utils';
import { classNames, style as styleMethod, useOnesyTheme } from '@onesy/style-react';
import TooltipElement from '../Tooltip';
import IconButtonElement from '../IconButton';
import { staticClassName } from '../utils';
const useStyle = styleMethod(theme => ({
  root: {
    position: 'relative',
    lineHeight: '0'
  },
  no_render: {
    '& .onesy-Button-root': {
      boxShadow: theme.shadows.values.default[6],
      '&:hover': {
        boxShadow: theme.shadows.values.default[8]
      },
      '&.onesy-Button-focus': {
        boxShadow: theme.shadows.values.default[8]
      }
    }
  }
}), {
  name: 'onesy-SpeedDialItem'
});
const SpeedDialItem = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useOnesyTheme();
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.onesySpeedDialItem?.props?.default), props_), [props_]);
  const Tooltip = React.useMemo(() => theme?.elements?.Tooltip || TooltipElement, [theme]);
  const IconButton = React.useMemo(() => theme?.elements?.IconButton || IconButtonElement, [theme]);
  const {
      open,
      name,
      label: label_,
      tooltipOpen,
      closeOnClick,
      render,
      onBlur,
      onFocus,
      Icon,
      TooltipProps = {
        alignment: 'center',
        interactive: false
      },
      Component = 'div',
      className,
      children
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();
  delete TooltipProps.open;
  if (tooltipOpen) TooltipProps.open = true;
  const label = name !== undefined ? name : label_;
  return /*#__PURE__*/React.createElement(Component, {
    ref: ref,
    className: classNames([staticClassName('SpeedDialItem', theme) && [`onesy-SpeedDialItem-root`], className, classes.root, !is('function', render) && classes.no_render])
  }, is('function', render) ? render(_objectSpread({
    onBlur,
    onFocus,
    TooltipProps
  }, other)) : /*#__PURE__*/React.createElement(Tooltip, _extends({
    name: label,
    portal: true,
    nowrap: true
  }, TooltipProps), /*#__PURE__*/React.createElement(IconButton, _extends({
    onBlur: onBlur,
    onFocus: onFocus
  }, other), /*#__PURE__*/React.createElement(Icon, null))));
});
SpeedDialItem.displayName = 'onesy-SpeedDialItem';
export default SpeedDialItem;