import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
const _excluded = ["tonal", "color", "size", "elevation", "header", "footer", "WrapperComponentProps", "TableComponent", "WrapperComponent", "Component", "className", "children"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
import React from 'react';
import { classNames, style as styleMethod, useOnesyTheme } from '@onesy/style-react';
import SurfaceElement from '../Surface';
import LineElement from '../Line';
import { staticClassName } from '../utils';
const useStyle = styleMethod(theme => ({
  root: _objectSpread({
    borderRadius: `${theme.shape.radius.unit * 2}px`,
    overflow: 'hidden'
  }, theme.typography.values.b2),
  table: {
    display: 'table',
    width: '100%',
    borderCollapse: 'collapse',
    borderSpacing: '0px',
    background: 'inherit'
  },
  wrapper: {
    overflowX: 'auto',
    background: 'inherit'
  }
}), {
  name: 'onesy-Table'
});
const Table = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useOnesyTheme();
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.onesyTable?.props?.default), props_), [props_]);
  const Line = React.useMemo(() => theme?.elements?.Line || LineElement, [theme]);
  const Surface = React.useMemo(() => theme?.elements?.Surface || SurfaceElement, [theme]);
  const {
      tonal = true,
      color = 'themed',
      size = 'regular',
      elevation = 1,
      header,
      footer,
      WrapperComponentProps,
      TableComponent = 'table',
      WrapperComponent = 'div',
      Component = 'div',
      className,
      children
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();
  return /*#__PURE__*/React.createElement(Line, _extends({
    ref: ref,
    gap: 0,
    direction: "column",
    align: "unset",
    justify: "unset",
    fullWidth: true,
    tonal: tonal,
    color: color,
    elevation: elevation,
    Component: Surface,
    AdditionalProps: {
      Component
    },
    className: classNames([staticClassName('Table', theme) && [`onesy-Table-root`, `onesy-Table-size-${size}`], className, classes.root])
  }, other), header && /*#__PURE__*/React.cloneElement(header, {
    tonal: header.props.tonal !== undefined ? header.props.tonal : tonal,
    color: header.props.color !== undefined ? header.props.color : color,
    size: header.props.size !== undefined ? header.props.size : size
  }), /*#__PURE__*/React.createElement(WrapperComponent, _extends({}, WrapperComponentProps, {
    className: classNames([staticClassName('Table', theme) && [`onesy-Table-wrapper`], WrapperComponentProps?.className, classes.wrapper])
  }), /*#__PURE__*/React.createElement(TableComponent, {
    className: classNames([staticClassName('Table', theme) && [`onesy-Table-table`, header && `onesy-Table-header`, footer && `onesy-Table-footer`], classes.table])
  }, React.Children.toArray(children).map(item => (/*#__PURE__*/React.cloneElement(item, {
    tonal: item.props.tonal !== undefined ? item.props.tonal : tonal,
    color: item.props.color !== undefined ? item.props.color : color,
    size: item.props.size !== undefined ? item.props.size : size
  }))))), footer && /*#__PURE__*/React.cloneElement(footer, {
    tonal: footer.props.tonal !== undefined ? footer.props.tonal : tonal,
    color: footer.props.color !== undefined ? footer.props.color : color,
    size: footer.props.size !== undefined ? footer.props.size : size
  }));
});
Table.displayName = 'onesy-Table';
export default Table;