import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
const _excluded = ["value", "columns", "responsive", "divider", "top", "bottom", "start", "end", "TypeProps", "HorizontalProps", "className", "children"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
import React from 'react';
import { is, isEnvironment, textToInnerHTML, unique } from '@onesy/utils';
import { classNames, style as styleMethod, useOnesyTheme } from '@onesy/style-react';
import TypeElement from '../Type';
import LineElement from '../Line';
import useMediaQuery from '../useMediaQuery';
import { valueBreakpoints, staticClassName } from '../utils';
const useStyle = styleMethod(theme => ({
  root: {},
  type: {
    columnGap: '40px'
  },
  divider: {
    columnRule: `1px solid ${theme.palette.text.divider}`
  },
  column_1: {
    columnCount: '1'
  },
  column_2: {
    columnCount: '2'
  },
  column_3: {
    columnCount: '3'
  },
  column_4: {
    columnCount: '4'
  }
}), {
  name: 'onesy-Text'
});
const Text = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useOnesyTheme();
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.onesyText?.props?.default), props_), [props_]);
  const Line = React.useMemo(() => theme?.elements?.Line || LineElement, [theme]);
  const Type = React.useMemo(() => theme?.elements?.Type || TypeElement, [theme]);
  const {
      value: value_,
      columns: columns_,
      responsive = true,
      divider,
      top,
      bottom,
      start,
      end,
      TypeProps,
      HorizontalProps,
      className,
      children
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();
  const refs = {
    root: React.useRef(undefined)
  };
  const keys = React.useMemo(() => {
    const result = [];
    const items = [columns_];
    items.forEach(item => {
      if (is('object', item)) Object.keys(item).filter(key => theme.breakpoints.media[key]).forEach(key => result.push(key));
    });
    return unique(result);
  }, [columns_]);
  const breakpoints = {};
  keys.forEach(key => {
    breakpoints[key] = useMediaQuery(theme.breakpoints.media[key], {
      element: refs.root.current
    });
  });
  let columns = valueBreakpoints(columns_, 1, breakpoints, theme);
  if (isEnvironment('browser') && responsive) {
    const width = window.innerWidth;

    // 0 - 479px
    if (width < 480) columns = Math.min(columns, 1);

    // 480px - 1023px
    if (width >= 480 && width < 1024) columns = Math.min(columns, 2);

    // 1024px - 1439px
    if (width >= 1024) columns = Math.min(columns, 3);
  }
  let value = value_ !== undefined ? value_ : children;
  value = is('string', value) ? textToInnerHTML(value) : '';
  const main = /*#__PURE__*/React.createElement(Type, _extends({
    version: "b2"
  }, TypeProps, {
    className: classNames([staticClassName('Text', theme) && ['onesy-Text-type'], TypeProps?.className, classes.type, divider && classes.divider, classes[`column_${columns}`]]),
    dangerouslySetInnerHTML: {
      __html: value
    }
  }));
  return /*#__PURE__*/React.createElement(Line, _extends({
    ref: item => {
      if (ref) {
        if (is('function', ref)) ref(item);else ref.current = item;
      }
      refs.root.current = item;
    },
    direction: "column",
    justify: "unset",
    align: "unset",
    className: classNames([staticClassName('Text', theme) && ['onesy-Text-root'], className, classes.root]),
    fullWidth: true
  }, other), top, /*#__PURE__*/React.createElement(Line, _extends({
    direction: "row",
    fullWidth: true
  }, HorizontalProps, {
    className: classNames([staticClassName('Text', theme) && ['onesy-Text-main'], HorizontalProps?.className, classes.main])
  }), main), bottom);
});
Text.displayName = 'onesy-Text';
export default Text;