import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
const _excluded = ["orientation", "start", "end", "DividerProps", "IconProps", "Icon", "Divider", "Component", "className", "children"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
import React from 'react';
import { classNames, style as styleMethod, useOnesyTheme } from '@onesy/style-react';
import SurfaceElement from '../Surface';
import DividerElement from '../Divider';
import LineElement from '../Line';
import { staticClassName } from '../utils';
const useStyle = styleMethod(theme => ({
  root: {
    '&:last-of-type': {
      '& $divider': {
        display: 'none'
      }
    }
  },
  orientation_vertical: {
    minHeight: '77px'
  },
  orientation_horizontal: {
    minWidth: '114px'
  },
  icon: {
    display: 'inline-block',
    width: '12px',
    height: '12px',
    borderRadius: theme.methods.shape.radius.value(40, 'px')
  },
  aside_orientation_vertical: {
    padding: `${theme.methods.space.value(0.5, 'px')} ${theme.methods.space.value(3, 'px')}`
  },
  aside_orientation_horizontal: {
    padding: `${theme.methods.space.value(3, 'px')} ${theme.methods.space.value(0.5, 'px')}`
  },
  iconWrapper: {
    lineHeight: '0'
  },
  iconWrapper_orientation_vertical: {
    marginBlock: '8px'
  },
  iconWrapper_orientation_horizontal: {
    marginInline: '8px'
  },
  divider: {
    '&.onesy-Divider-root': {
      margin: '0px'
    }
  },
  divider_orientation_vertical: {
    '&.onesy-Divider-root': {
      width: '2px'
    }
  },
  divider_orientation_horizontal: {
    '&.onesy-Divider-root': {
      height: '2px'
    }
  }
}), {
  name: 'onesy-TimelineItem'
});
const TimelineItem = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useOnesyTheme();
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.onesyTimelineItem?.props?.default), props_), [props_]);
  const Line = React.useMemo(() => theme?.elements?.Line || LineElement, [theme]);
  const Surface = React.useMemo(() => theme?.elements?.Surface || SurfaceElement, [theme]);
  const Divider = React.useMemo(() => theme?.elements?.Divider || DividerElement, [theme]);
  const {
      orientation = 'vertical',
      start,
      end,
      DividerProps: DividerProps_ = !props.Divider ? {
        tonal: 'secondary',
        color: 'neutral'
      } : undefined,
      IconProps = !props.Icon ? {
        tonal: 'secondary',
        color: 'neutral',
        version: 'filled'
      } : undefined,
      Icon,
      Divider: Divider_,
      Component = 'li',
      className,
      children
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();
  const direction = orientation === 'vertical' ? 'row' : 'column';
  const lineDirection = orientation === 'vertical' ? 'column' : 'row';
  const DividerProps = _objectSpread({}, DividerProps_);
  if (!Divider_) {
    DividerProps.orientation = orientation;
  }
  return /*#__PURE__*/React.createElement(Line, _extends({
    ref: ref,
    gap: 0,
    align: "unset",
    justify: "unset",
    direction: direction,
    Component: Component,
    className: classNames([staticClassName('TimelineItem', theme) && ['onesy-TimelineItem-root'], className, classes.root, classes[`orientation_${orientation}`]])
  }, other), start && /*#__PURE__*/React.createElement("div", {
    className: classNames([staticClassName('TimelineItem', theme) && ['onesy-TimelineItem-aside', 'onesy-TimelineItem-item', 'onesy-TimelineItem-start'], classes.aside, classes.item, classes.start, classes[`aside_orientation_${orientation}`]])
  }, start), /*#__PURE__*/React.createElement(Line, {
    gap: 0,
    direction: lineDirection,
    align: "center",
    justify: "flex-start",
    className: classNames([staticClassName('TimelineItem', theme) && ['onesy-TimelineItem-item', 'onesy-TimelineItem-middle'], classes.item, classes.middle])
  }, /*#__PURE__*/React.createElement("div", {
    className: classNames([staticClassName('TimelineItem', theme) && ['onesy-TimelineItem-icon-wrapper'], classes.iconWrapper, classes[`iconWrapper_orientation_${orientation}`]])
  }, Icon ? Icon : /*#__PURE__*/React.createElement(Surface, _extends({}, IconProps, {
    tonal: true,
    className: classNames([staticClassName('TimelineItem', theme) && ['onesy-TimelineItem-icon'], IconProps?.className, classes.icon])
  }))), Divider_ ? Divider_ : /*#__PURE__*/React.createElement(Divider, _extends({}, DividerProps, {
    className: classNames([staticClassName('TimelineItem', theme) && ['onesy-TimelineItem-divider'], DividerProps?.className, classes.divider, classes[`divider_orientation_${orientation}`]]),
    flex: true
  }))), (end || children) && /*#__PURE__*/React.createElement("div", {
    className: classNames([staticClassName('TimelineItem', theme) && ['onesy-TimelineItem-aside', 'onesy-TimelineItem-item', 'onesy-TimelineItem-end'], classes.aside, classes.item, classes.end, classes[`aside_orientation_${orientation}`]])
  }, end || children));
});
TimelineItem.displayName = 'onesy-TimelineItem';
export default TimelineItem;