import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
const _excluded = ["size", "icon", "className"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
import React from 'react';
import { classNames, style as styleMethod, useOnesyTheme } from '@onesy/style-react';
import ChipElement from '../Chip';
import { staticClassName } from '../utils';
const useStyle = styleMethod(theme => ({
  root: {
    '&.onesy-Chip-root': {
      width: 'unset'
    }
  },
  size_small: {
    '&.onesy-Button-root': {
      padding: `${theme.methods.space.value(0.5, 'px')} ${theme.methods.space.value(0.75, 'px')}`
    }
  },
  size_regular: {
    '&.onesy-Button-root': {
      padding: `${theme.methods.space.value(1, 'px')} ${theme.methods.space.value(1, 'px')}`
    }
  },
  size_large: {
    '&.onesy-Button-root': {
      padding: `${theme.methods.space.value(1.5, 'px')} ${theme.methods.space.value(1.25, 'px')}`
    }
  }
}), {
  name: 'onesy-ToggleButton'
});
const ToggleButton = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useOnesyTheme();
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.onesyToggleButton?.props?.default), props_), [props_]);
  const Chip = React.useMemo(() => theme?.elements?.Chip || ChipElement, [theme]);
  const {
      size,
      icon = true,
      className
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();
  return /*#__PURE__*/React.createElement(Chip, _extends({
    ref: ref,
    size: size,
    icon: icon,
    noCheckIcon: true,
    className: classNames([staticClassName('ToggleButton', theme) && ['onesy-ToggleButton-root', `onesy-ToggleButton-size-${size}`], className, classes.root, classes[`size_${size}`]])
  }, other));
});
ToggleButton.displayName = 'onesy-ToggleButton';
export default ToggleButton;