import _defineProperty from "@babel/runtime/helpers/defineProperty";
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
import React from 'react';
import { useLocation as useLocationReactRouterDOM } from 'react-router-dom';
import { debounce, isEnvironment } from '@onesy/utils';
const useLocation = props => {
  const {} = props || {};
  const locationReactRouterDOM = isEnvironment('browser') && !window.navigation ? useLocationReactRouterDOM() : undefined;
  const [response, setResponse] = React.useState(isEnvironment('browser') ? _objectSpread({}, window.location) : {});
  const onUpdate = React.useCallback(debounce(function () {
    let value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _objectSpread({}, window.location);
    setResponse(value);
  }, 40), []);

  // React router DOM
  React.useEffect(() => {
    if (locationReactRouterDOM) onUpdate(locationReactRouterDOM);
  }, [locationReactRouterDOM]);
  const method = React.useCallback(() => {
    onUpdate();
  }, []);
  React.useEffect(() => {
    if (!isEnvironment('browser')) return;

    // New API
    if (window.navigation) {
      window.navigation.addEventListener('navigate', method);
    }
    // Old method
    else {
      window.addEventListener('popstate', method);
      window.addEventListener('hashchange', method);
    }
    return () => {
      // Clean up
      // New API
      if (window.navigation) {
        window.navigation.removeEventListener('navigate', method);
      }
      // Old method
      else {
        window.removeEventListener('popstate', method);
        window.removeEventListener('hashchange', method);
      }
    };
  }, []);
  return response;
};
useLocation.displayName = 'onesy-UseLocation';
export default useLocation;