/// <reference types="react" />
import { IBreakpoint, TPaletteVersion } from '@onesy/style-react';
export declare type IPoint = [number, number];
export declare type ITonal = true | false | 'secondary';
declare type RGB = `rgb(${number}, ${number}, ${number})`;
declare type RGBA = `rgba(${number}, ${number}, ${number}, ${number})`;
declare type HSL = `hsl(${number}, ${number}, ${number})`;
declare type HSLA = `hsla(${number}, ${number}, ${number}, ${number})`;
declare type HEX = `#${string}`;
declare type Color = RGB | RGBA | HSL | HSLA | HEX;
export declare type IColor = 'default' | 'themed' | 'inverted' | 'inherit' | TPaletteVersion | Color;
export declare type IVersion = 'filled' | 'outlined' | 'outlined-without-background' | 'text';
export declare type ISize = 'small' | 'regular' | 'large';
export declare type ISizeExtended = 'very small' | 'small' | 'regular' | 'medium' | 'large' | 'very large';
export declare type ISizeAny = ISize | number;
export declare type ISizeExtendedAny = ISizeExtended | number;
export declare type IElevation = 0 | 1 | 2 | 3 | 4 | 6 | 8 | 9 | 12 | 16 | 24;
export declare type IElementReference = string | React.FC<any> | (React.ForwardRefExoticComponent<any>);
export declare type IElement = React.ReactNode | React.ReactNode[] | React.ReactElement<any, string | React.JSXElementConstructor<any>>;
export declare type IElementAny = IElement | string | number | boolean | null | undefined;
export declare type IHTMLElement = Element | HTMLElement;
export declare type IPropsAny = Record<string, any>;
export declare type IStyle = React.CSSProperties | undefined;
export declare type IChildren = React.ReactNode | React.ReactNode[];
export declare type IRef = React.MutableRefObject<any>;
export declare type IBaseElement<P = {}, T = HTMLElement> = Omit<React.HTMLAttributes<T>, 'onClick' | 'onChange' | 'onInput' | 'onKeyDown' | 'onMouseEnter' | 'onMouseLeave' | 'onDoubleClick' | 'onSubmit'> & {
    tonal?: ITonal;
    color?: IColor;
    size?: ISizeAny;
    onClick?: any;
    onChange?: any;
    onInput?: any;
    onKeyDown?: any;
    onMouseEnter?: any;
    onMouseLeave?: any;
    onDoubleClick?: any;
    onSubmit?: any;
    readOnly?: boolean;
    disabled?: boolean;
    children?: any;
    Component?: any;
    ref?: any;
} & P;
export declare type IMethodTransition = (element?: IHTMLElement) => any;
export declare type IValueBreakpoints = IBreakpoint | 'default';
export declare type IMediaObject = {
    id?: string;
    name?: string;
    mime?: string;
    url: string;
    urlSmall?: string;
    urlEmbed?: string;
};
export {};
